// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "NineK2.h"

#include "MainFrm.h"
#include ".\mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	// Global help commands
	//ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	//ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	//ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	//ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
	ON_WM_GETMINMAXINFO()
ON_WM_CLOSE()
ON_WM_TIMER()
END_MESSAGE_MAP()



// CMainFrame construction/destruction

CMainFrame::CMainFrame()
: 
m_AllowClose(false)
{
	
}

CMainFrame::~CMainFrame()
{
	
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	
	SetWindowText(g_CaptionApp);

	//	      
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	
	
	//        
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	

	ReadSettingFromReg();
	

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers

void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	//      
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	//       
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CMainFrame::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	
	// --          --

	//         
	CRect rc1;
	rc1.left   = 0;
	rc1.top    = 0;
	rc1.right  = 636;
	rc1.bottom = 487;
	int height_menu = GetSystemMetrics(SM_CYMENUSIZE);
	rc1.bottom += height_menu;
	
	if(m_wndToolBar.m_hWnd != NULL)
		if(m_wndToolBar.IsWindowVisible() == TRUE)
		{
			CRect rc;
			m_wndToolBar.GetClientRect(&rc);
			rc1.bottom += rc.Height();
		}

	CalcWindowRect(&rc1, CWnd::adjustOutside );

	lpMMI->ptMinTrackSize.x = rc1.Width();
	lpMMI->ptMinTrackSize.y = rc1.Height();


	//    
	lpMMI->ptMaxTrackSize.x = 1600;
	lpMMI->ptMaxTrackSize.y = 1280;
	

	CFrameWnd::OnGetMinMaxInfo(lpMMI);
}


//     
void CMainFrame::WriteSettingToReg(void)
{
	HKEY hkey;

    if( ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, APP_REGKEY_PUBLIC, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, NULL ) )
    {
		WINDOWPLACEMENT wp;
		this->GetWindowPlacement(&wp);
		Util_WriteIntRegKey( hkey, TEXT("Left"),     wp.rcNormalPosition.left);
		Util_WriteIntRegKey( hkey, TEXT("Top"),	     wp.rcNormalPosition.top);
		Util_WriteIntRegKey( hkey, TEXT("Width"),    wp.rcNormalPosition.right);
        Util_WriteIntRegKey( hkey, TEXT("Height"),   wp.rcNormalPosition.bottom);
		Util_WriteIntRegKey( hkey, TEXT("ShowMode"), wp.showCmd);
		

        RegCloseKey( hkey );
    }
}

//            
void CMainFrame::ReadSettingFromReg(void)
{
	HKEY hkey;
    if( ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, APP_REGKEY_PUBLIC, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, NULL ) )
    {
		
		int m_dwCreationWidth = 0, m_dwCreationHeight = 0;
		WINDOWPLACEMENT wp;
		Util_ReadIntRegKey( hkey, TEXT("Left"),    (DWORD*)&wp.rcNormalPosition.left,  100);
		Util_ReadIntRegKey( hkey, TEXT("Top"),     (DWORD*)&wp.rcNormalPosition.top,   100);
		Util_ReadIntRegKey( hkey, TEXT("Width"),   (DWORD*)&wp.rcNormalPosition.right,  m_dwCreationWidth );
		Util_ReadIntRegKey( hkey, TEXT("Height"),  (DWORD*)&wp.rcNormalPosition.bottom, m_dwCreationHeight );
		
		this->SetWindowPlacement(&wp);
        RegCloseKey( hkey );
    }
}

void CMainFrame::OnClose()
{
	//             
	//        
	//   OnIdle() ,
	//       ,
	//    ,    
	if(	m_AllowClose == false)
	{
		m_wndView.StopGame();
		SetTimer(ID_TIMER_WAITCLOSEAPP, 100, NULL);
		ShowWindow(SW_HIDE);
	}
	else
	{
		WriteSettingToReg();
		CFrameWnd::OnClose();
	}
}

void CMainFrame::OnTimer(UINT nIDEvent)
{
	 if(nIDEvent == ID_TIMER_WAITCLOSEAPP)
	 {	  
		//     ,
		//   
		if(m_wndView.IsStopGame() == true)
		{
			KillTimer(ID_TIMER_WAITCLOSEAPP);
			m_AllowClose = true;
			OnClose();
		}

		//    10      
		//    
		static int count = 0;
		count++;
		if(count == 100)
		{
			KillTimer(ID_TIMER_WAITCLOSEAPP);
			DestroyWindow();
		}
	 }


	//    
	 // ..       
	//CFrameWnd::OnTimer(nIDEvent);
}

