// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "NineKNet1.h"
#include "ChildView.h"
#include ".\childview.h"
#include "MainFrm.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#endif


extern int g_NumberPlayers;

bool Test = false;

///////////////////////////////////////////////////////////////////////////////
//    ,    
///////////////////////////////////////////////////////////////////////////////
UINT BEGINGAME(LPVOID pParam)
{
	//          ,
	//     ASSERT,
	//    Release     .
	//  -  MFC  m_hWnd ,
	//        
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->BeginGame();
	pWnd->m_CountProcess--;

	return 0;
}

//   
UINT ONENDGAME(LPVOID pParam)
{
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->OnEndGame();
	pWnd->m_CountProcess--;

	return 0;
}

//  
UINT GOUSER(LPVOID pParam)
{
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->GoUser();
	pWnd->m_CountProcess--;

	return 0;
}

//    
//     
UINT ROLLPLAYER(LPVOID pParam)
{
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->RollForNet();
	pWnd->m_CountProcess--;

	return 0;
}

//     
//     
UINT GOCARD(LPVOID pParam)
{
	CChildView* pWnd = (CChildView*)pParam;
	pWnd->m_CountProcess++;
	pWnd->GoCardForNet();
	pWnd->m_CountProcess--;

	return 0;
}


// CChildView
CChildView::CChildView()
: m_GOINGPLAYER(0)
, m_pCardUser(NULL)
, m_NumberGames(0)
, m_EnableNextGame(false)
, m_EnableNewParty(true)
, m_bLocalPlayer(false)
, m_CountProcess(0)
, m_StopProcess(false)
//, m_GamePlayer(false)
, m_DistrOk(true)
, m_AllowActiveChildView(true)
, m_AllowGoCard(true)
{
	
}

CChildView::~CChildView()
{
	WriteSettingToReg();
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_CREATE()

	ON_MESSAGE(WM_CARDLBUTTONDOWN, OnCardLButtonDown)
	ON_MESSAGE(WM_PAGESETTING, OnPublicSetting)
	ON_MESSAGE(WM_MYEDIT_CHANGE, OnMyEditOnEnChange)

	ON_MESSAGE(WM_DPN_MSGID_CONNECT_COMPLETE, On_DPN_MSGID_CONNECT_COMPLETE)
	ON_MESSAGE(WM_DPN_MSGID_INDICATE_CONNECT, On_DPN_MSGID_INDICATE_CONNECT)
	ON_MESSAGE(WM_DPN_MSGID_CREATE_PLAYER, On_DPN_MSGID_CREATE_PLAYER)
	ON_MESSAGE(WM_DPN_MSGID_DESTROY_PLAYER, On_DPN_MSGID_DESTROY_PLAYER)
	ON_MESSAGE(WM_DPN_MSGID_PEER_INFO, On_DPN_MSGID_PEER_INFO)

	ON_MESSAGE(WM_MSGCHECKIDLE, On_MSGCHECKIDLE)
	ON_MESSAGE(WM_MSGSERVICEGAME, On_MSGSERVICEGAME)

	ON_COMMAND(ID_HELPAPP, OnHelpApp)

	ON_WM_SIZE()
	ON_COMMAND(ID_FILE_SETNAME, OnFileSetname)
	ON_WM_TIMER()
	ON_COMMAND(ID_NET_DOGAME, OnNetDogame)
	ON_COMMAND(ID_FILE_NEWPARTY, OnFileNewparty)
	ON_COMMAND(ID_FILE_STATISTICS, OnFileStatistics)
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_FILE_NEXTGAME, OnFileNextgame)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEXTGAME, OnUpdateFileNextgame)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_SETTING, OnSetting)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEWPARTY, OnUpdateFileNewparty)
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()

 

// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.style |= WS_CLIPCHILDREN;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
	return -1;


	//   
	m_DirectPlay.m_pParent = this;

	m_Decoration.m_NUMBERPLAYERS = 1;
	m_Decoration.InitDecoration(this, true);


	m_Decoration.m_Pack.CardsToPack();
	m_Decoration.m_Pack.SetPackPos(5, -100);
	//m_Decoration.m_Pack.OpenAllCards(true); //   


	//    
	ReadSettingFromReg();


	//     
	if(m_Decoration.m_RequestName == true)
	{
		m_Decoration.SetPlayersName();
	}
	
	//       
	m_Decoration.m_Player[0].SetMoney(m_Decoration.m_maxMoney);
	m_DirectPlay.SetPlayerInfo(&m_Decoration.m_Player[0].m_DataPlayer);

	m_wndGameStatistics.InitWnd(this);
	m_SearchPlayers.InitSearchPlayers(this);
	m_wndChatTablo.InitChatTablo(this, m_Decoration.m_ChatVisible);


	m_Decoration.m_mainLabel.SetText("  !");

	return 0;
}


void CChildView::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	//      (CChildView)
	int center_x = cx/2;
	int center_y = cy/2;

	m_Decoration.OnSize(cx, cy);
	m_SearchPlayers.SetPos(cx/2, cy/2);
	m_Decoration.m_mainLabel.SetPos(cx/2, cy/2 - m_Decoration.m_mainLabel.GetTextRect().Height()/2 - 4, 1);

	//      
	m_wndGameStatistics.SetWndPos(cx/2, cy/2, true);

	//      ,
	//     
	if(cx > 1120)
		m_wndChatTablo.SizeChatTablo(3, g_NumberPlayers);
	else if(cx > 890)
		m_wndChatTablo.SizeChatTablo(2, g_NumberPlayers);
	else 
		m_wndChatTablo.SizeChatTablo(1, g_NumberPlayers);

	m_wndChatTablo.SetChatTabloPos(cx - m_wndChatTablo.m_Rect.Width() - 2, cy - m_wndChatTablo.m_Rect.Height() - 2);
}

void CChildView::OnTimer(UINT nIDEvent)
{

	if(nIDEvent == ID_TIMER_REQUESTIDLE)
	{
		//      
		if(IsStopGame() == true)
		{
			KillTimer(ID_TIMER_REQUESTIDLE);

			SendRequestIdle();
		}
	}

	if(nIDEvent == ID_TIMER_WAITNEXTGAME)
	{
		if(IsStopGame() == true)
		{
			KillTimer(ID_TIMER_WAITNEXTGAME);
			OnFileNextgame();
		}
	}


	//       .
	m_Decoration.m_mainLabel.OnTimer(nIDEvent);

	CWnd::OnTimer(nIDEvent);
}


///////////////////////////////////////////////////////////////////////////////
//		       
///////////////////////////////////////////////////////////////////////////////

//      
//    ,       
void CChildView::SendSafeMessage(const int& select_function)
{
	//       ,
	//     ,   
	//      
	//     ,    
	//        
	
	m_vecMsg.push_back(select_function);

	//       
	//    
	SetTimer(ID_TIMER_REQUESTIDLE, 100, NULL);
}

//      
void CChildView::SendRequestIdle(void)
{
	//    
	SetAllowActiveChildView(false);
	
	//      
	MSG_SAFE msg_safe;
	msg_safe.msg_type = CDirectPlay::msgRequestIdle;
	msg_safe.id_player = m_DirectPlay.m_IDLocalPlayer;

	
	//   ,   
	m_DirectPlay.SendToGroup(&msg_safe, sizeof(MSG_SAFE), true);
}

//    
//        
//     MSG_SAFE.
UINT TIMER_REPLYIDLE(LPVOID pParam)
{
	MSG_SAFE* pMsgSafe = (MSG_SAFE*)pParam;
	CChildView* pParent = (CChildView*)pMsgSafe->pParent;

	while(true)
	{
		//    
		if(pParent->IsStopGame() == true)
		{
			//    
			pParent->SetAllowActiveChildView(false);

			//         
			pMsgSafe->msg_type = CDirectPlay::msgReplyIdle;
			pParent->m_DirectPlay.SendToPlayer(pMsgSafe->id_player, pMsgSafe, sizeof(MSG_SAFE), true);
			break;
		}

		//       -  ,
		//    "".
		//     ,
		//     .
		HANDLE g_h = CreateEvent(0, true, false, "1");
		//
		WaitForSingleObject(g_h, 100);
	}
	
	free(pMsgSafe);

	return 0;
}

//     ,
//      
//     
LRESULT CChildView::On_MSGCHECKIDLE(WPARAM wParam, LPARAM lParam)
{
	switch(wParam)
	{
		//     
	case CDirectPlay::msgRequestIdle:
		{
			//     
			//      
			//  ()   o  
			MSG_SAFE* pMsgSafe = (MSG_SAFE*)lParam;
			pMsgSafe->pParent = this;
			AfxBeginThread(TIMER_REPLYIDLE, pMsgSafe);
		}
		break;
	case CDirectPlay::msgReplyIdle:
		{
			//     malloc
			//    DPN_MSGID_RECEIVE  DPMessageHandler
			free((void*)lParam);

			static int count_reply = 0;
			count_reply++;
			//        
			if(count_reply == (g_NumberPlayers-1))
			{
				
				//     
				for(int i = 0; i < m_vecMsg.size(); i++)
				{
					if(m_vecMsg[i] != 0)
					{
						//    
						SelectSendFunction(m_vecMsg[i]);
					}
				}
				
				m_vecMsg.clear();				
				count_reply = 0;
			}
		}
		break;
	}


	return 0;
}

//-----------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////
//     DIRECTPLAY - HRESULT WINAPI DPMessageHandler( PVOID pvUserContext, DWORD dwMessageId, PVOID pMsgBuffer)
///////////////////////////////////////////////////////////////////////////////

//    -   .
//    .
LRESULT CChildView::On_DPN_MSGID_CONNECT_COMPLETE(WPARAM wParam, LPARAM lParam)
{
	//    
	if(wParam == S_OK)
	{
		//m_Decoration.m_mainLabel.SetText(" !");
		//       .
		//m_Decoration.m_mainLabel.SetText("  !");
		//if(m_Decoration.m_NUMBERPLAYERS < g_NumberPlayers)
			//AfxMessageBox("KL");
		//Beep(3000, 100);
	}

	return LRESULT();
}

//   ,  CreatePlayer
LRESULT CChildView::On_DPN_MSGID_INDICATE_CONNECT(WPARAM wParam, LPARAM lParam)
{
	
	return LRESULT();
}

//   
LRESULT CChildView::On_DPN_MSGID_CREATE_PLAYER(WPARAM wParam, LPARAM lParam)
{
	try
	{
		//      ,
		//        
		// DPN_MSGID_CREATE_PLAYER  DPMessageHandler.
		CDataPlayer DataPlayer;
		memcpy(&DataPlayer, (void*)wParam, sizeof(CDataPlayer));
		delete ((CDataPlayer*)wParam);

		if(m_DirectPlay.m_Mode != CDirectPlay::modeHost) return 0;
		//     .

	
		//     ,   
		//  .
		if(m_EnableNewParty == true)
		{
			//   -   
			m_Decoration.m_NUMBERPLAYERS = g_NumberPlayers;

			//     ,   .
			if(g_NumberPlayers == 1)
			{
				//    .
				//m_GamePlayer = true;
				
				m_Decoration.m_Player[g_NumberPlayers-1].CopyDataPlayer(DataPlayer);
				m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer = true;
				m_Decoration.m_mainLabel.SetText("  !");
			}
			else if(g_NumberPlayers > 1)
			{
				m_Decoration.m_Player[g_NumberPlayers-1].CopyDataPlayer(DataPlayer);
				m_Decoration.m_Player[g_NumberPlayers-1].m_DataPlayer.m_GamePlayer = true;

				//      .
				SendSafeMessage(CDirectPlay::msgInitPlayers);
				
				m_Decoration.m_mainLabel.SetText("  !");
			}
			


		}// if(m_EnableNewParty == true)
		else
		{
			//     ,
			//       .
			m_Decoration.m_Player[g_NumberPlayers-1].CopyDataPlayer(DataPlayer);
			SendSafeMessage(CDirectPlay::msgInitNewPlayers);
		}

		//    
		for(int i = 1; i < g_NumberPlayers; i++)
		{
			m_wndChatTablo.SetName(i,  m_Decoration.m_Player[i].GetName());
		}
		DoOnSize();

	}
	catch(...)
	{
		AfxMessageBox("On_DPN_MSGID_CREATE_PLAYER(");
	}

	return LRESULT();
}

//    (  )
LRESULT CChildView::On_DPN_MSGID_DESTROY_PLAYER(WPARAM wParam, LPARAM lParam)
{
	try
	{
		//     ,
		// -    ()  .
		g_NumberPlayers--;

		//      ,
		//      
		//  DirectPlay    CDirectPlay::Disconnect().
		if(g_NumberPlayers == 0)
		{
			m_Decoration.m_mainLabel.SetText("  !");
			g_NumberPlayers = 0;
			m_Decoration.m_NUMBERPLAYERS = 1;
			m_Decoration.m_Player[0].SetMoney(m_Decoration.m_maxMoney);
			//    ,    .
			m_Decoration.m_Pack.CardsToPack();

			// ""    .
			for(int i = 1; i < MAXPLAYERS; i++)
			{
				m_Decoration.m_Player[i].Show(false);
			}

			//       .
			//m_GamePlayer = false;
			m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer = false;

			m_Decoration.MessageWnd("   !", CMessageBox::MMB_OK);
			return 0;
		}

		//      ,
		//    
		//    
		if(g_NumberPlayers == 1)
		{
			//             
			//m_GamePlayer = true;
			m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer = true;
			m_EnableNewParty = true;
			m_Decoration.m_mainLabel.SetText("  !");
			m_Decoration.m_NUMBERPLAYERS = 1;
			m_Decoration.m_Player[0].SetMoney(m_Decoration.m_maxMoney);
			//    ,    .
			m_Decoration.m_Pack.CardsToPack();

			// ""    .
			for(int i = 1; i < MAXPLAYERS; i++)
			{
				m_Decoration.m_Player[i].Show(false);
			}

			return 0;
		}

		//    
		CString NameOutPlayer;

		//    ,
		//  (  () ).
		bool destroy_gameplayer = false;
		for(int i = 0; i < MAXPLAYERS; i++)
		{
			if(m_Decoration.m_Player[i].m_DataPlayer.m_IDPlayer == m_DirectPlay.m_IDPlayer)
			{
				
				//      ,
				//     .
				m_Decoration.m_Player[i].m_DataPlayer.m_IDPlayer = 0;

				//    .
				NameOutPlayer = m_Decoration.m_Player[i].GetName();
				
				
				//    ,  ()
				//       (  ),
				// ..  i() < m_Decoration.m_NUMBERPLAYERS( ),
				//    ;
				//  i() >= m_Decoration.m_NUMBERPLAYERS( ),
				//   () 
				//if(i < m_Decoration.m_NUMBERPLAYERS)
				//{
					//     ,
					//    .
					//m_Decoration.m_NUMBERPLAYERS--;
					//destroy_gameplayer = true;
				//}
				if(m_Decoration.m_Player[i].m_DataPlayer.m_GamePlayer == true)
				{
					//     ,
					//    .
					m_Decoration.m_NUMBERPLAYERS--;
					destroy_gameplayer = true;
				}
				
				break;
			}
		}

		// ------------     ---------------
		//      .
		for(int i = 0; i < MAXPLAYERS; i++)
		{
			m_Decoration.m_Player[i].Show(false);
		}

		//   , ,  
		//      .
		CPlayer players[4];
		int count_new = 0;
		for(int i = 0; i < MAXPLAYERS; i++)
		{
			//    ,
			//       .
			// ..   3-   1-2-3-4,  
			// 2-   ,   .
			if(m_Decoration.m_Player[i].m_DataPlayer.m_IDPlayer != 0)
			{
				memcpy(&players[count_new].m_DataPlayer, &m_Decoration.m_Player[i].m_DataPlayer, sizeof(CDataPlayer));
				count_new++;
				
			}
		}

		//      ""  ,
		//       ,  .
		for(int i = 0; i < MAXPLAYERS; i++)
		{
			m_Decoration.m_Player[i].CopyDataPlayer(players[i].m_DataPlayer);
		}

		//     .
		for(int i = 0; i < m_Decoration.m_NUMBERPLAYERS; i++)
		{
			m_Decoration.m_Player[i].Show(true);
		}
		// --------    -----------------------


		
		//      
		//if(m_GamePlayer == false)
		if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == false)
		{
			if(destroy_gameplayer == true)
			{
				m_Decoration.MessageWnd("   " + NameOutPlayer + "!" + "\n   !", CMessageBox::MMB_OK);
				m_Decoration.m_mainLabel.SetText("  !");
				m_Decoration.m_Pack.CardsToPack();
				m_EnableNewParty = true;
			}
			else
			{
				m_Decoration.MessageWnd("   " + NameOutPlayer + "!", CMessageBox::MMB_OK);
			}
		}
		else
		{
			if(destroy_gameplayer == false)
			{
				//    ,
				//     
				if(m_DirectPlay.m_Mode == CDirectPlay::modeHost)
					SendSafeMessage(CDirectPlay::msgDataNewPlayers);
			}
			else
			{
				//   .
				if(m_Decoration.MessageWnd("   " + NameOutPlayer + "!" + "\n !", CMessageBox::MMB_OK) == IDOK)
				{
				
					//    .
					if(m_DirectPlay.m_Mode == CDirectPlay::modeHost)
					{
						m_Decoration.m_mainLabel.SetText("  !");
						//       ,
						//   () .
						if(m_Decoration.m_NUMBERPLAYERS == 1)
							SendSafeMessage(CDirectPlay::msgReInitPlayers);

					}
					else if(m_DirectPlay.m_Mode == CDirectPlay::modeClient)
						m_Decoration.m_mainLabel.SetText("  !");

					//    ,
					//   -  ,
					//    ,
					//    ,
					//  ,   
					AfxGetMainWnd()->SetWindowText(APPTITLE);
					m_Decoration.m_Pack.CardsToPack();
					m_EnableNewParty = true;
				}
				
			}// else if(destroy_gameplayer == false)
		}
		
		

		//   OnSize()   
		//  
		DoOnSize();
	}
	catch(...)
	{
		AfxMessageBox("On_DESTROY_PLAYER()");
	}

	return 0;
}

//        
LRESULT CChildView::On_MSGSERVICEGAME(WPARAM wParam, LPARAM lParam)
{
	switch(wParam)
	{
	case CDirectPlay::msgInitPlayers:
		{
			try
			{
				PLAYERS_DATA* pd = (PLAYERS_DATA*)lParam;

				//      
				if(m_DirectPlay.m_Mode == CDirectPlay::modeClient)
				{
					m_Decoration.m_mainLabel.SetText("  !");


					////     
					//m_GamePlayer = true;
					//m_Decoration.m_NUMBERPLAYERS = g_NumberPlayers;

					//      
					int index;
					for(index = 0; index < MAXPLAYERS; index++)
					{
						if(pd->data_player[index].m_IDPlayer == m_DirectPlay.m_IDLocalPlayer)
						{
							break;
						}
					}

					//    -    ,
					//       .
					// ,   ,  ,    ,
					//      
					int count_player = 0;
					for(int p = 0; p < MAXPLAYERS; p++)
					{
						//    
						if(pd->data_player[index].m_IDPlayer != 0)
						{
							m_Decoration.m_Player[count_player].CopyDataPlayer(pd->data_player[index]);
							count_player++;
						}

						index++;
						if(index == 4)
							index = 0;
					}

				}// else if(m_DirectPlay.m_Mode == CDirectPlay::modeClient)


				//     
				//m_GamePlayer = true;
				//m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer = true;
				m_Decoration.m_NUMBERPLAYERS = g_NumberPlayers;


				//      
				//    
				for(int i = 0; i < m_Decoration.m_NUMBERPLAYERS; i++)
				{
					if(i > 0)
						m_wndChatTablo.SetName(i,  m_Decoration.m_Player[i].GetName());

					m_Decoration.m_Player[i].Show(true);
				}

				DoOnSize();

				

				//    , ..   - 
				if(m_bLocalPlayer == true)
				{
					SendSafeMessage(CDirectPlay::msgNewParty);
				}

			}
			catch(...)
			{
				AfxMessageBox("CDirectPlay::msgInitPlayers:");
			}
		}
		break;
	case CDirectPlay::msgInitNewPlayers:
		{
			try
			{
				//       ,
				//      ,
				//        
				//if(m_GamePlayer == false)
				if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == false)
				{
					m_Decoration.m_mainLabel.SetText("  !");
					break;
				}

				PLAYERS_DATA* pd = (PLAYERS_DATA*)lParam;

				if(m_DirectPlay.m_Mode == CDirectPlay::modeClient)
				{

					//        
					int number_newplayers = g_NumberPlayers - m_Decoration.m_NUMBERPLAYERS;
					for(int i = m_Decoration.m_NUMBERPLAYERS; i < g_NumberPlayers; i++)
					{
						m_Decoration.m_Player[i].CopyDataPlayer(pd->data_player[i]);
					}
					
					for(int i = 1; i < g_NumberPlayers; i++)
					{
						m_wndChatTablo.SetName(i,  m_Decoration.m_Player[i].GetName());
					}
					DoOnSize();

				}// if(m_DirectPlay.m_Mode == CDirectPlay::modeClient)

			}
			catch(...)
			{
				AfxMessageBox("CDirectPlay::msgInitNewPlayers:");
			}
		
		}
		break;
	case CDirectPlay::msgDataNewPlayers:
		{
			try
			{

				//       
				//      
				//  ,  ,  .
				//if(m_GamePlayer == true) break;
				if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == true) break;

				NEWPLAYERS_DATA* new_pd = (NEWPLAYERS_DATA*)lParam;

				if(m_DirectPlay.m_Mode == CDirectPlay::modeClient)
				{
					//     
					int index;
					for(index = 0; index < MAXPLAYERS; index++)
					{
						if(new_pd->data_player[index].m_IDPlayer == m_DirectPlay.m_IDLocalPlayer)
							break;
					}
					
					
					//       ,
					//   .
					int count_player = 0;
					int number_players[4] = {0};
					for(int p = 0; p < MAXPLAYERS; p++)
					{
						if(new_pd->data_player[index].m_IDPlayer != 0)
						{
							m_Decoration.m_Player[count_player].CopyDataPlayer(new_pd->data_player[index]);
							//       ,
							//    .
							number_players[count_player] = m_Decoration.m_Player[count_player].m_DataPlayer.m_IDPlayer;
							count_player++;
						}

						index++;
						if(index == 4)
							index = 0;
					}

					//   
					m_NumberGames = new_pd->number_games;
					m_Decoration.m_NUMBERPLAYERS = g_NumberPlayers;
					m_Decoration.m_BankGame.SetMoney(new_pd->bank_money);

				
					//  
					for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
					{
						for(int j = 0; j < 36; j++)
						{
							if( m_Decoration.m_Pack.GetCard(i)->m_Mast  == new_pd->data_card[j].mast &&
								m_Decoration.m_Pack.GetCard(i)->m_Value == new_pd->data_card[j].value)
							{
								m_Decoration.m_Pack.GetCard(i)->m_State = new_pd->data_card[j].state;
								for(int p = 0; p < 4; p++)
								{
									//         
									if(number_players[p] == new_pd->data_card[j].id_player)
									{
										m_Decoration.m_Pack.GetCard(i)->m_Player = p + 1;
										m_Decoration.m_Pack.GetCard(i)->SetWindowPos(&CWnd::wndTop, 0,0,0,0, SWP_NOMOVE|SWP_NOSIZE);

										//    ,    
										if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::m_eTable)
										{
											m_Decoration.m_Pack.GetCard(i)->CardClose(false);
										}

										break;
									}
								}
								break;
							}
						}
					}// for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)

					//      .
					for(int i = 0; i < m_Decoration.m_NUMBERPLAYERS; i++)
					{
						m_Decoration.m_Player[i].Show(true);
					}

					//      .
					for(int i = 1; i < g_NumberPlayers; i++)
					{
						m_wndChatTablo.SetName(i,  m_Decoration.m_Player[i].GetName());
					}

					DoOnSize();


				}// if(m_DirectPlay.m_Mode == CDirectPlay::modeClient)

			}
			catch(...)
			{
				AfxMessageBox("CDirectPlay::msgDataNewPlayers:");
			}
		
		}
		break;
	
	case CDirectPlay::msgReInitPlayers:
		{
			try
			{
				//m_Decoration.m_mainLabel.SetText(" ...");

				//      
				if(m_DirectPlay.m_Mode == CDirectPlay::modeHost)
				{
					//      
					m_Decoration.m_NUMBERPLAYERS = g_NumberPlayers;
					//      
					for(int i = 0; i < m_Decoration.m_NUMBERPLAYERS; i++)
						m_Decoration.m_Player[i].m_DataPlayer.m_GamePlayer = true;

					//     .
					SendSafeMessage(CDirectPlay::msgInitPlayers);
				}

			}
			catch(...)
			{
				AfxMessageBox("CDirectPlay::msgReInitPlayers:");
			}
		}
		break;
	case CDirectPlay::msgNewParty:
		{
			try
			{
				INITNEWPARTY* newparty = (INITNEWPARTY*)lParam;
				m_Decoration.m_maxMoney = newparty->number_money;

				NewParty();
			}
			catch(...)
			{
				AfxMessageBox("CDirectPlay::msgNewParty:");
			}
		}
		break;
	case CDirectPlay::msgNextGame:
		{
			try
			{
				//       
				//     
				//if(m_GamePlayer == false)
				if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == false)
				{
					m_Decoration.m_Pack.CardsToPack();
					m_Decoration.m_mainLabel.SetText(" ...");
				}

				NextGame();

			}
			catch(...)
			{
				AfxMessageBox("CDirectPlay::msgNextGame:");
			}
		}
		break;
	case CDirectPlay::msgDistrCards:
		{
			try
			{

				//       . 
				//if(m_GamePlayer == false)
				if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == false)
				{
					break;
				}

				DATA_DISTRCARDS* distr_cards = (DATA_DISTRCARDS*)lParam;

				for(int i = 0; i < m_Decoration.m_NUMBERPLAYERS; i++)
				{
					if(m_Decoration.m_Player[i].m_DataPlayer.m_IDPlayer == distr_cards->id_player)
					{
						m_GOINGPLAYER = i+1;
						break;
					}
				}

				//      ( 4   4  -), 
				//       
				//        
				if(DistrCards(m_GOINGPLAYER, distr_cards->mast, distr_cards->value) == false)
				{
					//     ,     ,
					// ..   
					if(m_bLocalPlayer == true)
						SendSafeMessage(CDirectPlay::msgDistrCards);
				}
				else
				{  
					//          
					m_bLocalPlayer = false;
				}

			}
			catch(...)
			{
				AfxMessageBox("CDirectPlay::msgDistrCards:");
			}

		}
		break;
	case CDirectPlay::msgGoPlayer:
		{
			try
			{
			
				ID_PLAYER* id_player = (ID_PLAYER*)lParam;

				//   
				for(int i = 0; i < m_Decoration.m_NUMBERPLAYERS; i++)
				{
					if(m_Decoration.m_Player[i].m_DataPlayer.m_IDPlayer == id_player->id_player)
					{
						m_GOINGPLAYER = i+1;
						break;
					}
				}

				//    
				if(m_GOINGPLAYER == 0) break;
				

				//         
				//      
				if(DeterminationGoingPlayer() == true)
				{
					if(m_GOINGPLAYER == 1)
						m_Decoration.m_mainLabel.SetText(" !");
					else if(m_GOINGPLAYER > 1)
					{
						CString s;
						s = " " + m_Decoration.m_Player[m_GOINGPLAYER-1].GetName() + "!";
						m_Decoration.m_mainLabel.SetText(s);
					}
				}// 
				else
				{
					// --     --
					
					//            ,
					//       
					bool rool = false;
					for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
					{
						if(m_Decoration.m_Pack.GetCard(i)->m_Player == m_GOINGPLAYER)
						{
							rool = true;
						}
					}

					
					//       ,  
					if(IsCanGo(m_GOINGPLAYER) == false)
					{
						//   
						if(rool == true)
						{
							//   ,    
							//   
							if(m_GOINGPLAYER == 1)
							{
								//     
								//     .    
								//if(m_GamePlayer == true)
								if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == true)
								{
									m_Decoration.m_mainLabel.SetText(" !");
									SendSafeMessage(CDirectPlay::msgRollingPlayer);
								}// if(m_GamePlayer == true)
								
								
							}
							else
							{
								
								//    
								CString s;
								s = "  " + m_Decoration.m_Player[m_GOINGPLAYER-1].GetName() + "!";
								m_Decoration.m_mainLabel.SetText(s);
							}

						}// if(rool == true)
						
						
					}// if(IsCanGo(m_GOINGPLAYER) == false)
					else
					{
						//      
						if(m_GOINGPLAYER == 1)
							m_Decoration.m_mainLabel.SetText(" !");
						else
						{
							CString s;
							s = " " + m_Decoration.m_Player[m_GOINGPLAYER-1].GetName() + "!";
							m_Decoration.m_mainLabel.SetText(s);
						}
					}// else if(IsCanGo(m_GOINGPLAYER) == false)

							
						
				}// else if(DeterminationGoingPlayer() == true)

				//    
				m_Decoration.m_mainLabel.ShowText(true);
				

				if(m_DirectPlay.m_Mode == CDirectPlay::modeHost)
				{
					//    ,   
					//      ,
					//         
					//   
					if(g_NumberPlayers > m_Decoration.m_NUMBERPLAYERS)
						SendSafeMessage(CDirectPlay::msgDataNewPlayers);
				}

			}
			catch(...)
			{
				AfxMessageBox("CDirectPlay::msgGoPlayer:");
			}

		}
		break;
	case CDirectPlay::msgRollingPlayer:
		{
			//       ,
			//    
			AfxBeginThread(ROLLPLAYER, this);	
		}
		break;
	case CDirectPlay::msgGoCard:
		{
			try
			{	

				//      -   
				memcpy(&m_DataCard, (void*)lParam, sizeof(DATA_CARD));
				//       ,
				//    
				AfxBeginThread(GOCARD, this);
			}
			catch(...)
			{
				AfxMessageBox("CDirectPlay::msgGoCard:");
			}
			
		}
		break;
	case CDirectPlay::msgPlayersChat:
		{
			try
			{
				PLAYERS_CHAT* msg_chat = (PLAYERS_CHAT*)lParam;

				//     
				int chat_player = 0;
				for(int i = 0; i < m_Decoration.m_NUMBERPLAYERS; i++)
				{
					if(m_Decoration.m_Player[i].m_DataPlayer.m_IDPlayer == msg_chat->id_player)
					{
						chat_player = i;
						break;
					}
				}
				//        
				//   
				m_wndChatTablo.SetText(i, msg_chat->chat_buffer);

			}
			catch(...)
			{
				AfxMessageBox("CDirectPlay::msgPlayersChat:");
			}
		}

		break;
	case CDirectPlay::msgStopProcess:
		//    .
		StopGame();
		break;

	}// switch(wParam)


	//       
	//  free()     malloc()
	//  DPMessageHandler -  DPN_MSGID_RECEIVE
	free((void*)lParam);

	//AfxGetMainWnd()->EnableWindow();
	SetAllowActiveChildView(true);

	return 0;
}

//    ,
//      
//   ,   DirectPlay
//  GetPeerInfo    
LRESULT CChildView::On_DPN_MSGID_PEER_INFO(WPARAM wParam, LPARAM lParam)
{
	try
	{
		CDataPlayer data_player;		
		m_DirectPlay.GetPlayerInfo(m_DirectPlay.m_IDPlayer, &data_player); 

		//     
		for(int i = 0; i < MAXPLAYERS; i++)
		{
			if(m_DirectPlay.m_IDPlayer == m_Decoration.m_Player[i].m_DataPlayer.m_IDPlayer)
			{
				m_Decoration.m_Player[i].SetName(data_player.m_Name);
				break;
			}
		}

		//      
		for(int i = 1; i < g_NumberPlayers; i++)
		{
			m_wndChatTablo.SetName(i,  m_Decoration.m_Player[i].GetName());
		}

	}
	catch(...)
	{
		AfxMessageBox("On_DPN_MSGID_PEER_INFO(WPARAM w");
	}

	return 0;
}
//-----------------------------------------------------------------------------


///////////////////////////////////////////////////////////////////////////////
//           
///////////////////////////////////////////////////////////////////////////////
//      :
//    ,   ,    

//      
//  
void CChildView::SelectSendFunction(const int& sel_func)
{
	switch(sel_func)	
	{
	case CDirectPlay::msgInitPlayers:
		SendInitPlayers();
		break;
	case CDirectPlay::msgInitNewPlayers:
		SendInitNewPlayers();
		break;
	case CDirectPlay::msgDataNewPlayers:
		SendDataNewPlayers();
		break;
	case CDirectPlay::msgReInitPlayers:
		SendReInitPlayers();
		break;
	case CDirectPlay::msgNewParty:
		SendNewParty();
		break;
	case CDirectPlay::msgNextGame:
		SendNextGame();
		break;
	case CDirectPlay::msgDistrCards:
		SendDistrCards();
		break;
	case CDirectPlay::msgGoPlayer:
		SendGoPlayer();
		break;
	case CDirectPlay::msgGoCard:
		SendGoCard();
		break;
	case CDirectPlay::msgRollingPlayer:
		SendRollingPlayer();
		break;
	}

}


//         
void CChildView::SendInitPlayers(void)
{
	//     
	if(m_DirectPlay.m_Mode == CDirectPlay::modeHost)
	{ 
		PLAYERS_DATA pd;
		pd.msg_type = CDirectPlay::msgInitPlayers;
		
		for(int i = 0; i < m_Decoration.m_NUMBERPLAYERS; i++)
		{
			memcpy(&pd.data_player[i], &m_Decoration.m_Player[i].m_DataPlayer, sizeof(CDataPlayer));
		}

		m_DirectPlay.SendToGroup(&pd, sizeof(PLAYERS_DATA), false);
	}
}

//             
void CChildView::SendInitNewPlayers(void)
{
	//     
	if(m_DirectPlay.m_Mode == CDirectPlay::modeHost)
	{ 
		PLAYERS_DATA pd;
		pd.msg_type = CDirectPlay::msgInitNewPlayers;

		//       
		for(int i = 0; i < g_NumberPlayers; i++)
		{
			pd.data_player[i] = m_Decoration.m_Player[i].m_DataPlayer;
		}
		
		m_DirectPlay.SendToGroup(&pd, sizeof(PLAYERS_DATA), false);

	}// if(m_DirectPlay.m_Mode == CDirectPlay::modeHost)
}

//         
void CChildView::SendDataNewPlayers(void)
{
	//     
	if(m_DirectPlay.m_Mode == CDirectPlay::modeHost)
	{ 
		NEWPLAYERS_DATA new_pd;
		new_pd.msg_type = CDirectPlay::msgDataNewPlayers;

		//     
		for(int i = 0; i < g_NumberPlayers; i++)
		{
			new_pd.data_player[i] = m_Decoration.m_Player[i].m_DataPlayer;
		}
		
		//   ,      
		for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
		{
			
			int id_player = m_Decoration.m_Player[m_Decoration.m_Pack.GetCard(i)->m_Player - 1].m_DataPlayer.m_IDPlayer;
			new_pd.data_card[i].id_player = id_player;
			new_pd.data_card[i].mast  = m_Decoration.m_Pack.GetCard(i)->m_Mast;
			new_pd.data_card[i].value = m_Decoration.m_Pack.GetCard(i)->m_Value;
			new_pd.data_card[i].state = m_Decoration.m_Pack.GetCard(i)->m_State;
		}

		//     
		new_pd.bank_money   = m_Decoration.m_BankGame.GetMoney();
		new_pd.number_games = m_NumberGames;
		
		m_DirectPlay.SendToGroup(&new_pd, sizeof(NEWPLAYERS_DATA), false);

	}// if(m_DirectPlay.m_Mode == CDirectPlay::modeHost)
}

//      
//      
void CChildView::SendReInitPlayers(void)
{
	MSG_TYPE msg_reinit;
	msg_reinit.msg_type = CDirectPlay::msgReInitPlayers;
	m_DirectPlay.SendToGroup(&msg_reinit, sizeof(MSG_TYPE), false);
}

//     
void CChildView::SendNewParty(void)
{
	INITNEWPARTY newparty;
	newparty.msg_type = CDirectPlay::msgNewParty;

	//  ,       .
	newparty.number_money = m_Decoration.m_maxMoney;

	m_DirectPlay.SendToGroup(&newparty, sizeof(INITNEWPARTY), false);
}

// 	    
void CChildView::SendNextGame(void)
{
	MSG_TYPE msg_nextgame;
	msg_nextgame.msg_type = CDirectPlay::msgNextGame;
	m_DirectPlay.SendToGroup(&msg_nextgame, sizeof(MSG_TYPE), false);
}

//     
void CChildView::SendDistrCards(void)
{
	DATA_DISTRCARDS distr_cards;
	distr_cards.msg_type = CDirectPlay::msgDistrCards;
	distr_cards.id_player = m_DirectPlay.m_IDLocalPlayer;
	m_Decoration.m_Pack.ShufflePack(distr_cards.mast, distr_cards.value);
	m_DirectPlay.SendToGroup(&distr_cards, sizeof(DATA_DISTRCARDS), false);
}

//     
void CChildView::SendGoPlayer(void)
{
	ID_PLAYER id_player;
	id_player.msg_type = CDirectPlay::msgGoPlayer;
	id_player.id_player = m_Decoration.m_Player[m_GOINGPLAYER-1].m_DataPlayer.m_IDPlayer;
	m_DirectPlay.SendToGroup(&id_player, sizeof(ID_PLAYER), false);

}

//     
void CChildView::SendGoCard(void)
{
	DATA_CARD data_card;
	data_card.msg_type = CDirectPlay::msgGoCard;
	data_card.id_player = m_Decoration.m_Player[m_GOINGPLAYER-1].m_DataPlayer.m_IDPlayer;
	data_card.mast  = m_pCardUser->m_Mast;
	data_card.value = m_pCardUser->m_Value;
	m_DirectPlay.SendToGroup(&data_card, sizeof(DATA_CARD), false);
}

//    
void CChildView::SendRollingPlayer(void)
{
	MSG_TYPE msg_rollplayer;
	msg_rollplayer.msg_type = CDirectPlay::msgRollingPlayer;
	m_DirectPlay.SendToGroup(&msg_rollplayer, sizeof(MSG_TYPE), false);
}

//   
void CChildView::SendStopProcess(void)
{
	MSG_TYPE msg_stopprocess;
	msg_stopprocess.msg_type = CDirectPlay::msgStopProcess;
	m_DirectPlay.SendToGroup(&msg_stopprocess, sizeof(MSG_TYPE), false);
}

//          
void CChildView::OnFileSetname()
{
	
	m_Decoration.SetPlayersName();
	m_DirectPlay.SetPlayerInfo(&m_Decoration.m_Player[0].m_DataPlayer);
}

//     
void CChildView::OnFileStatistics()
{
	SetStatistics();

	m_wndGameStatistics.Show(true);
}

//     
void CChildView::DoOnSize(void)
{
	CRect rc;
	GetClientRect(&rc);
	OnSize(0, rc.right, rc.bottom);
}

//   
void CChildView::OnNetDogame()
{
	m_DirectPlay.DoNetwork();
}


//   
void CChildView::OnFileNewparty()
{
	//          
	//      
	if(IsStopGame() == false)
	{
		m_Decoration.MessageWnd("      .", CMessageBox::MMB_OK);
		return;
	}

	//        
	if(IsEndParty() == false)	
		if(m_Decoration.MessageWnd("   !\n     ?", CMessageBox::MMB_YESNO) == IDCANCEL)
			return;

	//    ,   
	//    ,
	//    ,     ,
	// ..  -    
	if(m_Decoration.m_NUMBERPLAYERS < g_NumberPlayers)
	{
		//     ,
		//        
		//   .
		//         
		//  ,    .
		if(m_Decoration.m_NUMBERPLAYERS > 1)
		{
			if(m_Decoration.MessageWnd("    .     ?", CMessageBox::MMB_YESNO) == IDOK)
			{
				//     
				m_bLocalPlayer = true;
				//     
				SendSafeMessage(CDirectPlay::msgReInitPlayers);
				return;
			}
		}
		else
		{
			//     
			m_bLocalPlayer = true;
			//     
			SendSafeMessage(CDirectPlay::msgReInitPlayers);
			return;
		}
	}

	//      
	//       
	if(m_Decoration.m_NUMBERPLAYERS > 1)
	{
		//     ,
		//          
		m_bLocalPlayer = true;
		//       
		//  ,   .
		//        
		SendSafeMessage(CDirectPlay::msgNewParty);
	}
}

//      " "
void CChildView::OnUpdateFileNewparty(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(FALSE);

	//      (),
	//      2   .
	if(m_DirectPlay.m_Mode == CDirectPlay::modeHost && g_NumberPlayers >= 2)
		pCmdUI->Enable(TRUE);
		
}

//     
void CChildView::OnFileNextgame()
{
	//    ,   
	//   " "
	m_EnableNextGame = FALSE;

	//  -   
	//        
	//    .
	if(IsStopGame() == false)
	{
		SendStopProcess();
		//      
		SetTimer(ID_TIMER_WAITNEXTGAME, 0, NULL);
	}
	else
	{
		//    
		//    
		m_bLocalPlayer = true;
		SendSafeMessage(CDirectPlay::msgNextGame);
	}
}

//     " "
void CChildView::OnUpdateFileNextgame(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_EnableNextGame);
}

//   
void CChildView::NewParty(void)
{
	//       
	m_EnableNewParty = false;

	//    ,     ,
	//      ,    
	//         ,
	//            
	//  ,         
	//     .
	m_Decoration.EndMessageWnd();
	m_Decoration.m_Pack.CardsToPack();
	

	//       
	ResetNewParty();
	
	//     
	AfxBeginThread(BEGINGAME, this);
}

//   
void CChildView::NextGame(void)
{
	//     
	AfxBeginThread(BEGINGAME, this);
}

//   
void CChildView::BeginGame(void)
{
	//        
	//         
	//    .
	ContinueGame();

	//   
	//       
	m_EnableNextGame = false;

	//   m_DistrOk      
	//if(m_GamePlayer == true)
	if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == true)
		m_DistrOk = false;

	//   
	m_NumberGames++;
	CString str_numbergame;
	str_numbergame.Format("%d", m_NumberGames);
	CString apptitle = CString(APPTITLE) + " -  " + str_numbergame;
	AfxGetMainWnd()->SetWindowText(apptitle);

	
	//         
	//     ,  
	int i = 0;
	//if(m_GamePlayer == false)
	if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == false)
		i = 1;
	//        
	for(; i < m_Decoration.m_NUMBERPLAYERS; i++)
	{
		//    
		int player_money = m_Decoration.m_Player[i].GetMoney();
		player_money -= 10;
		m_Decoration.m_Player[i].SetMoney(player_money);

		//       
		m_Decoration.AnimMoneyToBank(i+1);

		//    
		int bank_money = m_Decoration.m_BankGame.GetMoney();
		bank_money += 10;
		m_Decoration.m_BankGame.SetMoney(bank_money);
	}

	
	//   
	SetStatistics();
	
	//    ,
	//    
	//    
	if(m_bLocalPlayer == true)
	{
		SendSafeMessage(CDirectPlay::msgDistrCards);
	}
}


//   
bool CChildView::DistrCards(const int& distr_player,  char mast[36], char value[36])
{
	//        
	m_Decoration.m_Pack.ArrayShuffle(mast, value);
	//        
	//      
	m_Decoration.m_Pack.CardsToPack();

	//   
	m_Decoration.DoDistr(distr_player);
	
	//       
	//       
	//  -    
	if(m_StopProcess == true)
	{
		m_DistrOk = true;
		return true;
	}
	

	//  -    4   4 
	//      false   
	if(m_Decoration.Check4Nine4Tuz() == true)
	{
		return false;
	}

	//    
	m_DistrOk = true;

	//        ,
	//       
	if(m_bLocalPlayer == true)
	{
		//        
		SendSafeMessage(CDirectPlay::msgGoPlayer);	
	}
	

	return true;
}



//       
void CChildView::ResetNewParty(void)
{
	m_Decoration.m_mainLabel.SetText(" !");
	m_NumberGames = 0;

	for(int p = 0; p < m_Decoration.m_NUMBERPLAYERS; p++)
	{
		m_Decoration.m_Player[p].SetMoney(m_Decoration.m_maxMoney);
		m_Decoration.m_Player[p].m_DataPlayer.m_NumberRoll = 0;
		m_Decoration.m_Player[p].m_DataPlayer.m_NumberVictory  = 0;
	}
	
	//  
	m_Decoration.m_BankGame.SetMoney(0);
	//   
	SetStatistics();
	
}

BOOL CChildView::OnEraseBkgnd(CDC* pDC)
{
	m_Decoration.SetDC(pDC);
	m_Decoration.m_mainLabel.Draw(pDC);

	return TRUE; //CWnd::OnEraseBkgnd(pDC);
}


//     
LRESULT CChildView::OnCardLButtonDown(WPARAM wParam, LPARAM lParam)
{
	//   m_pCardUser  ,   
	// GoUser   ,       
	//  GOUSER,        CChildView
	m_pCardUser = (CCard*)wParam;
	if(m_pCardUser != NULL)
		GoUser();

	return LRESULT();
}

//  
void CChildView::GoUser(void)
{
	CCard* pCard = m_pCardUser;
	//     ()
	//       - 
	//         false,
	//        GoCardForNet()
	//         
	if(m_AllowGoCard == false) return;
	m_AllowGoCard = false;

	//      
	bool is_endgame = false;
	for(int p = 1; p <= m_Decoration.m_NUMBERPLAYERS; p++)
	{
		if(IsEndCards(p) == true)
		{
			is_endgame = true;
			break;
		}
	}

	//      ,
	//     ,
	//     " ",
	//    ,
	//     ,
	//       ( ) - 
	//     -   -   ,
	//         
	if( is_endgame == true ||
		pCard->m_State  != CPack::StateCards::m_ePlayer ||
		pCard->m_Player != 1 ||
		m_GOINGPLAYER   != 1 ||
		m_GoCards.size() == 0)
	{
		m_AllowGoCard = true;
		
		return;
	}

	//   ,      
	//      
	bool allright = false;
	for(int i = 0; i < (int)m_GoCards.size(); i++)
	{
		if( pCard->m_Mast  == m_GoCards[i].mast &&
			pCard->m_Value == m_GoCards[i].value)
		{
			allright = true;
			break;
		}
	}

	//      ,  
	//      
	if(allright == false)
	{
		m_AllowGoCard = true;
		m_Decoration.m_mainLabel.SetTempText("   !");
		m_Decoration.m_mainLabel.ShowText(true);
		return;
	}

	// --     --

	//  
	m_Decoration.m_mainLabel.ShowText(false);
	
	//   (  )    
	if(pCard != NULL)
	{
		//     
		SendSafeMessage(CDirectPlay::msgGoCard);
	}

}

//       
bool CChildView::IsCanGo(const int go_player)
{
	//       
	m_GoCards.clear();

	// --         --

	//             
	//  
	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
		{
			for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)
			{
				if( m_Decoration.m_Pack.GetCard(p)->m_State == CPack::StateCards::m_ePlayer)
					if(m_Decoration.m_Pack.GetCard(p)->m_Player == go_player)
						if( m_Decoration.m_Pack.GetCard(p)->m_Mast  == m_Decoration.m_Pack.GetCard(i)->m_Mast &&
							(m_Decoration.m_Pack.GetCard(p)->m_Value+1) == m_Decoration.m_Pack.GetCard(i)->m_Value)
						{
							card temp;
							temp.mast  = m_Decoration.m_Pack.GetCard(p)->m_Mast;
							temp.value = m_Decoration.m_Pack.GetCard(p)->m_Value;
							m_GoCards.push_back(temp);
							break;
						}

			}// for(int p = 0; p < m_Pack.GetNumberCardsInPack(); p++)
		}// if(m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
	}// for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)

	//             
	//  
	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
		{
			for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)
			{
				if( m_Decoration.m_Pack.GetCard(p)->m_State == CPack::StateCards::m_ePlayer)
					if(m_Decoration.m_Pack.GetCard(p)->m_Player == go_player)
						if( m_Decoration.m_Pack.GetCard(p)->m_Mast  == m_Decoration.m_Pack.GetCard(i)->m_Mast &&
							 (m_Decoration.m_Pack.GetCard(p)->m_Value-1) == m_Decoration.m_Pack.GetCard(i)->m_Value)
						{
							card temp;
							temp.mast  = m_Decoration.m_Pack.GetCard(p)->m_Mast;
							temp.value = m_Decoration.m_Pack.GetCard(p)->m_Value;
							m_GoCards.push_back(temp);
							break;
						}

			}// for(int p = 0; p < m_Pack.GetNumberCardsInPack(); p++)
		}// if(m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
	}// for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)

	//   
	for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)
	{
		if( m_Decoration.m_Pack.GetCard(p)->m_State == CPack::StateCards::m_ePlayer)
			if(m_Decoration.m_Pack.GetCard(p)->m_Player == go_player)
				if(m_Decoration.m_Pack.GetCard(p)->m_Value == 4)
				{
					card temp;
					temp.mast = m_Decoration.m_Pack.GetCard(p)->m_Mast;
					temp.value = m_Decoration.m_Pack.GetCard(p)->m_Value;
					m_GoCards.push_back(temp);
				}

	}// for(int p = 0; p < m_Pack.GetNumberCardsInPack(); p++)

	return (m_GoCards.size() > 0);
}

//      
bool CChildView::IsEndCards(const int player)
{
	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer)
			if(m_Decoration.m_Pack.GetCard(i)->m_Player == player)
				return false;
	}

	return true;
}

//     - 
bool CChildView::IsEndMoney(void)
{
	for(int p = 0; p < m_Decoration.m_NUMBERPLAYERS; p++)
	{
		if(m_Decoration.m_Player[p].GetMoney() <= 0)
		{
			// --          --

			//         ,
			//       ,  > 0 -  ,
			//  <= 0 -  
			if(m_GOINGPLAYER == (p+1))
				if( (m_Decoration.m_BankGame.GetMoney() + m_Decoration.m_Player[p].GetMoney()) > 0)
				{
					return false;
				}

			return true;
		}
	}

	return false;
}

//   
void CChildView::OnEndGame(void)
{

	//   ,   
	if(IsEndMoney() == false)
	{
		//      ,
		//   
		if(m_GOINGPLAYER == 1)
		{
			
			m_EnableNextGame = true;
			m_Decoration.m_mainLabel.SetText(" !");
		}
		else
			m_Decoration.m_mainLabel.SetText("  " + m_Decoration.m_Player[m_GOINGPLAYER-1].GetName() + "!");
		
		m_Decoration.m_mainLabel.ShowText(true);
		
		// --      --

		//     
		m_Decoration.m_Player[m_GOINGPLAYER-1].m_DataPlayer.m_NumberVictory++;
		int player_money = m_Decoration.m_Player[m_GOINGPLAYER-1].GetMoney();
		
		//     
		int bank_money = m_Decoration.m_BankGame.GetMoney();
		int temp = bank_money;
		//      
		for(int i = 0; i < bank_money/10; i++)
		{
			temp -= 10;
			m_Decoration.m_BankGame.SetMoney(temp);
			m_Decoration.AnimMoneyToPlayer(m_GOINGPLAYER);
			player_money += 10;
			m_Decoration.m_Player[m_GOINGPLAYER-1].SetMoney(player_money);
		}
		

		//        
		m_GOINGPLAYER++;
		if(m_GOINGPLAYER > m_Decoration.m_NUMBERPLAYERS)
			m_GOINGPLAYER = 1;

		//   
		SetStatistics();
	}
	else //  
	{
		
		//     
		m_Decoration.m_Player[m_GOINGPLAYER-1].m_DataPlayer.m_NumberVictory++;

		// --     --

		int player_money = m_Decoration.m_Player[m_GOINGPLAYER-1].GetMoney();
		int bank_money = m_Decoration.m_BankGame.GetMoney();
		int temp = bank_money;
		for(int i = 0; i < bank_money/10; i++)
		{
			temp -= 10;
			m_Decoration.m_BankGame.SetMoney(temp);
			m_Decoration.AnimMoneyToPlayer(m_GOINGPLAYER);
			player_money += 10;
			m_Decoration.m_Player[m_GOINGPLAYER-1].SetMoney(player_money);
		}

		//   
		m_Decoration.m_mainLabel.SetText(" !!!");
		m_Decoration.m_mainLabel.ShowText(true);

		//      
		Sleep(1000);
		
		SetStatistics();
		m_wndGameStatistics.Show(true);

		//    
		m_EnableNewParty = true;
	}

}


//      
//  true -        
// false -  , 
//    , 
//     , 
//      
//        
bool CChildView::DeterminationGoingPlayer(void)
{
	bool begin_newparty;

	//     ,    
	bool is_cardtable = false;
	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
		{
			is_cardtable = true;
			break;
		}
	}

	
	//       
	m_GoCards.clear();
	//   
	if(m_NumberGames == 1 && is_cardtable == false)
	{
		//AfxMessageBox("m_NumberGames == 1 && is_cardtable == false");
		//     
		for(int p = 0; p < m_Decoration.m_Pack.GetNumberCardsInPack(); p++)
		{
			if(m_Decoration.m_Pack.GetCard(p)->m_Mast == 4 && m_Decoration.m_Pack.GetCard(p)->m_Value == 4)
			{
				m_GOINGPLAYER  = m_Decoration.m_Pack.GetCard(p)->m_Player;
				begin_newparty = true;
				card temp;
				temp.mast =  m_Decoration.m_Pack.GetCard(p)->m_Mast;
				temp.value = m_Decoration.m_Pack.GetCard(p)->m_Value;
				m_GoCards.push_back(temp);
				break;
			}
		}
	}
	//  
	else
	{
		//       
		//       
		//        .
		//          
		//  ,    
		if(is_cardtable == false)
		{
			m_GOINGPLAYER++;
			if(m_GOINGPLAYER > m_Decoration.m_NUMBERPLAYERS)
				m_GOINGPLAYER = 1;
		}
		
		
		begin_newparty = false;
	}

	
	return begin_newparty;
}

//     ,
//         
//         
bool SORTUSERCARDSFORROLL(CCard* _pcard1, CCard* _pcard2)
{
	return _pcard1->GetCardPos().x < _pcard2->GetCardPos().x;
}

//     
void CChildView::RollingUser(void)
{
	std::vector<CCard*> sort_x;
	for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer)
			if(m_Decoration.m_Pack.GetCard(i)->m_Player == m_GOINGPLAYER)
			{
				sort_x.push_back(m_Decoration.m_Pack.GetCard(i));
			}
	}
	std::sort(sort_x.begin(), sort_x.end(), SORTUSERCARDSFORROLL);
	for(int roll = 0; roll < (int)sort_x.size(); roll++)
	{
		int x = sort_x[roll]->GetCardPos().x;
		int y = sort_x[roll]->GetCardPos().y;
		sort_x[roll]->CardMove(x, y - 30, true);
		sort_x[roll]->CardMoveSound(x, y, 2);

		//    
		if(m_StopProcess == true)
			break;
	}

}

//  
void CChildView::RollingPlayer(void)
{
	//       
	//         m_Player[4]
	if(m_GOINGPLAYER < 1 || m_GOINGPLAYER > 4)
		return;

	if(m_GOINGPLAYER == 1)
	{
		RollingUser();
	}
	else
	{
		for(int i = (m_Decoration.m_Pack.GetNumberCardsInPack()-1); i >= 0; i--)
		{
			if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer)
				if(m_Decoration.m_Pack.GetCard(i)->m_Player == m_GOINGPLAYER)
				{
					int x = m_Decoration.m_Pack.GetCard(i)->GetCardPos().x;
					int y = m_Decoration.m_Pack.GetCard(i)->GetCardPos().y;
					switch(m_Decoration.m_NUMBERPLAYERS)
					{
					case 2:
						{
							switch(m_GOINGPLAYER)
							{
							case 1:
								m_Decoration.m_Pack.GetCard(i)->CardMove(x, y - 30, true);
								break;
							case 2:
								m_Decoration.m_Pack.GetCard(i)->CardMove(x, y + 30, true);
								break;
							}
						
						}
						break;
					case 3:
						{
							switch(m_GOINGPLAYER)
							{
							case 1:
								m_Decoration.m_Pack.GetCard(i)->CardMove(x, y - 30, true);
								break;
							case 2:
								m_Decoration.m_Pack.GetCard(i)->CardMove(x + 30, y, true);
								break;
							case 3:
								m_Decoration.m_Pack.GetCard(i)->CardMove(x - 30, y, true);
								break;
							}
						}
						break;
					case 4:
						{
							switch(m_GOINGPLAYER)
							{
							case 1:
								m_Decoration.m_Pack.GetCard(i)->CardMove(x, y - 30, true);
								break;
							case 2:
								m_Decoration.m_Pack.GetCard(i)->CardMove(x + 30, y, true);
								break;
							case 3:
								m_Decoration.m_Pack.GetCard(i)->CardMove(x, y + 30, true);
								break;
							case 4:
								m_Decoration.m_Pack.GetCard(i)->CardMove(x - 30, y, true);
								break;
							}
						}
						break;
					}// switch(m_NUMBERPLAYERS)
					
					//
					m_Decoration.m_Pack.GetCard(i)->CardMoveSound(x, y, 2);
					
					//    
					if(m_StopProcess == true)
					break;
				}
		}// for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)
	}// else if(m_GOINGPLAYER == 1)

	m_Decoration.m_Player[m_GOINGPLAYER-1].m_DataPlayer.m_NumberRoll++;
	int player_money = m_Decoration.m_Player[m_GOINGPLAYER-1].GetMoney();
	if(player_money != 0)
	{
		player_money -= 10;
		m_Decoration.m_Player[m_GOINGPLAYER-1].SetMoney(player_money);

		//       
		m_Decoration.AnimMoneyToBank(m_GOINGPLAYER);
		
		int bank_money = m_Decoration.m_BankGame.GetMoney();
		bank_money += 10;
		m_Decoration.m_BankGame.SetMoney(bank_money);
	}
	else
	{
		// TODO: - 
	}
	
	//   
	SetStatistics();
}


// 
void CChildView::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{
	//   --        ,         -- 
	/*COLORREF color_text = RGB(0,0,0);
	COLORREF color_newparty = RGB(0,0,255);
	COLORREF color_nextgame = RGB(255,0,0);
	bool enable_text = true;
	if(IsAllowActiveChildView() == false) 
	{
		color_text = color_newparty = color_nextgame = GetSysColor(COLOR_GRAYTEXT);
		enable_text = false;
	}

	CCustomMenu menu;
	menu.CreatePopupMenu();

	//      (),
	//      2   
	if(m_DirectPlay.m_Mode == CDirectPlay::modeHost && g_NumberPlayers >= 2)
		menu.AppendMenu(ID_FILE_NEWPARTY, " ", color_newparty, enable_text);
	else
		menu.AppendMenu(ID_FILE_NEWPARTY, " ", GetSysColor(COLOR_GRAYTEXT), false);

	if(m_EnableNextGame == TRUE)
		menu.AppendMenu(ID_FILE_NEXTGAME, " ", color_nextgame, enable_text);
	else
		menu.AppendMenu(ID_FILE_NEXTGAME, " ", GetSysColor(COLOR_GRAYTEXT), false);

	menu.AppendSeparator();
	menu.AppendMenu(ID_SETTING, "", color_text, enable_text);
	menu.AppendMenu(ID_FILE_SETNAME, "", color_text, enable_text);
	menu.AppendMenu(ID_FILE_STATISTICS, "", color_text, enable_text);
	menu.AppendMenu(ID_HELP_FINDER, "", color_text, enable_text);
	
	menu.TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON, point.x, point.y, this);
	*/

	//      ,
	//    
	CMenu menu;
	menu.CreatePopupMenu();

	if(m_EnableNextGame == TRUE)
		menu.AppendMenu(MF_STRING, ID_FILE_NEXTGAME, " ");
	else
		menu.AppendMenu(MF_GRAYED|MF_STRING, ID_FILE_NEXTGAME, " ");

	//      (),
	//      2   .
	if(m_DirectPlay.m_Mode == CDirectPlay::modeHost && g_NumberPlayers >= 2)
		menu.AppendMenu(MF_STRING, ID_FILE_NEWPARTY, " ");
	else
		menu.AppendMenu(MF_GRAYED|MF_STRING, ID_FILE_NEWPARTY, " ");

	menu.AppendMenu(MF_SEPARATOR);
	menu.AppendMenu(MF_STRING, ID_FILE_SETNAME, "");
	menu.AppendMenu(MF_STRING, ID_SETTING, "");
	
	menu.AppendMenu(MF_STRING, ID_FILE_STATISTICS, "");
	menu.AppendMenu(MF_STRING, ID_HELPAPP, "");
	
	menu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	
}


//   ,    
void CChildView::StopGame(void)
{
	//      
	//     
	m_StopProcess  = true;
	CCard::staticStopProcess     = true;
	CMoney::staticStopProcess    = true;
	CFinance::staticStopProcess	 = true;
	CSearchPlayers::staticStopProcess = true;
	m_DirectPlay.m_StopProccess = true;
}

//   
bool CChildView::IsStopGame(void)
{
	if(	CCard::staticCountProcess		== 0 &&
		m_CountProcess					== 0 && 
		CMoney::staticCountProcess		== 0 &&
		CFinance::staticCountProcess	== 0 &&
		CSearchPlayers::staticCountProcess == 0)
	{
		return true;
	}


	return false;
}

//       
void CChildView::ContinueGame(void)
{
	m_StopProcess  = false;
	CCard::staticStopProcess    = false;
	CMoney::staticStopProcess   = false;
	CFinance::staticStopProcess	= false;
	CSearchPlayers::staticStopProcess = false;
	m_DirectPlay.m_StopProccess = false;
}

//   
void CChildView::OnSetting()
{
	if(m_Decoration.m_pAdjustment != NULL)
	{
		if(m_DirectPlay.m_Mode == CDirectPlay::modeClient)
			m_Decoration.m_pAdjustment->m_PagePublicSetting.DisabledSetting(true);
		else
			m_Decoration.m_pAdjustment->m_PagePublicSetting.DisabledSetting(false);

		m_Decoration.m_pAdjustment->m_PagePublicSetting.SetCheckRadioMoney(m_Decoration.m_maxMoney);
		m_Decoration.m_pAdjustment->ShowWindow(SW_SHOW);
	}
}

//        
LRESULT CChildView::OnPublicSetting(WPARAM wParam, LPARAM lParam)
{
	m_Decoration.OnPublicSetting(wParam, lParam);

	//    
	//    .
	m_wndChatTablo.ShowChat(m_Decoration.m_ChatVisible);

	return LRESULT();
}

//    
void CChildView::ReadSettingFromReg(void)
{
	HKEY hkey;
    if( ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, APP_REGKEY_PUBLIC, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_READ, NULL, &hkey, NULL ) )
    {
		//  
		m_Decoration.ReadSettingFromReg(hkey);
		
        RegCloseKey( hkey );
    }
}

//      
void CChildView::WriteSettingToReg(void)
{
	HKEY hkey;

    if( ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, APP_REGKEY_PUBLIC, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, NULL ) )
    {
		m_Decoration.WriteSettingToReg(hkey);

        RegCloseKey( hkey );
    }
}

//    
void CChildView::RollForNet(void)
{
	try
	{
		RollingPlayer();

		// --         --
		//if(m_GamePlayer == false)
		if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == false)
		{
			return;
		}

		if(m_GOINGPLAYER == 1)
		{
			//        m_GOINGPLAYER
			//        DeterminationGoingPlayer()
			//     ,    
			bool is_cardtable = false;
			for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
			{
				if(m_Decoration.m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
				{
					is_cardtable = true;
					break;
				}
			}

			if(is_cardtable == true)
			{
				m_GOINGPLAYER++;
			}

			//        
			SendSafeMessage(CDirectPlay::msgGoPlayer);
		}

	}
	catch(...)
	{
		AfxMessageBox("RollForNet(void)");
	}
			
}

//      .
void CChildView::GoCardForNet(void)
{
	try
	{
		for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)
		{
			if(	m_Decoration.m_Pack.GetCard(i)->m_Mast  == m_DataCard.mast &&
				m_Decoration.m_Pack.GetCard(i)->m_Value == m_DataCard.value)
			{
				//           ,
				//      
				m_Decoration.m_Pack.GetCard(i)->m_State = CPack::StateCards::m_eTable;
				

				//    

				//         
				if(m_GOINGPLAYER >=1 && m_GOINGPLAYER <= 4)
				if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == true)
					if(IsEndCards(m_GOINGPLAYER) == false)
					{
						
						//   
						if(m_GOINGPLAYER == 1)
						{
							m_GOINGPLAYER++;
							//        
							SendSafeMessage(CDirectPlay::msgGoPlayer);
						}
					}
					else 
					{
						// --        --
						AfxBeginThread(ONENDGAME, this);
					}

				if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == false)
				{
					if(m_GOINGPLAYER > 1 && m_GOINGPLAYER <= 4)
					if(m_Decoration.m_Player[m_GOINGPLAYER-1].m_DataPlayer.m_GamePlayer == true)
					if(IsEndCards(m_GOINGPLAYER) == false)
					{
						
						//   
						if(m_GOINGPLAYER == 1)
						{
							m_GOINGPLAYER++;
							//        
							SendSafeMessage(CDirectPlay::msgGoPlayer);
						}
					}
					else 
					{
						// --        --
						AfxBeginThread(ONENDGAME, this);
					}
				}

					//if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == false)
					{
						CString s;
						s.Format("%d", m_GOINGPLAYER);
						AfxGetMainWnd()->SetWindowText(s);
					}


					
				

				m_GoCards.clear();
				//      
				// (  GoUser() )
				m_AllowGoCard = true;
				
				m_Decoration.m_Pack.GetCard(i)->BringWindowToTop();
				int row	   = m_Decoration.m_Pack.GetCard(i)->m_Mast-1;
				int column = m_Decoration.m_Pack.GetCard(i)->m_Value-1;
				int x = m_Decoration.m_ptCoordinateTable[row][column].x;
				int y = m_Decoration.m_ptCoordinateTable[row][column].y;
				m_Decoration.m_Pack.GetCard(i)->CardMoveSound(x, y, 1);

				//   
				int width  = m_Decoration.GetTableCardSize().cx;
				int height = m_Decoration.GetTableCardSize().cy;
				m_Decoration.m_Pack.GetCard(i)->SetWindowPos(NULL, 0, 0, width, height, SWP_NOMOVE);
				
				//    .
				m_Decoration.m_Pack.GetCard(i)->CardOpen(true, width, height);

				//         
				m_Decoration.m_Pack.GetCard(i)->SetWindowPos(&CWnd::wndBottom, 0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
				//     
				m_Decoration.RightPlayerCards(m_Decoration.m_Pack.GetCard(i)->m_Player);
				break;
			}
		}


	}
	catch(...)
	{
		AfxMessageBox("CChildView::GoCardForNet(void)");
	}
}

//       
LRESULT CChildView::OnMyEditOnEnChange(WPARAM wParam, LPARAM lParam)
{
	PLAYERS_CHAT msg_chat;
	CString s;
	m_wndChatTablo.m_CustomEdit.GetWindowText(s);
	memcpy(&msg_chat.chat_buffer, (void*)s.GetBuffer(), msg_chat.size_buffer*sizeof(TCHAR));
	msg_chat.msg_type = CDirectPlay::msgPlayersChat;
	msg_chat.id_player = m_DirectPlay.m_IDLocalPlayer;
	m_DirectPlay.SendToGroup(&msg_chat, sizeof(PLAYERS_CHAT), true);

	return 0;
}

//   
void CChildView::SetStatistics()
{
	//          
	//if(m_GamePlayer == false)
	if(m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == false)
	{
		//       ,
		CPlayer player[3];
		//        
		//  .
		int count_gameplayer = 0;
		for(int i = 1; i < g_NumberPlayers; i++)
		{
			if(m_Decoration.m_Player[i].m_DataPlayer.m_GamePlayer == true)
			{
				player[count_gameplayer].m_DataPlayer = m_Decoration.m_Player[i].m_DataPlayer;
				count_gameplayer++;
			}
		}
		m_wndGameStatistics.SetStatistics(player, count_gameplayer/*g_NumberPlayers-1*/, m_NumberGames);
	}
	else
	{
		m_wndGameStatistics.SetStatistics(m_Decoration.m_Player, m_Decoration.m_NUMBERPLAYERS, m_NumberGames);
	}
}


//   
void CChildView::OnHelpApp(void)
{
	m_Decoration.HelpApp();
}

void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if(nChar == VK_F1)
		OnHelpApp();

	//  F2   
	if(nChar == VK_F2)
		OnFileNewparty();

	//  F3   
	if(nChar == VK_F3)
	{
		OnFileStatistics();
	}

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}
