// Bank.cpp : implementation file
//

#include "stdafx.h"
#include "nine.h"
#include "Banks.h"
#include ".\banks.h"


/////////////////////////////////////////////////////////////////////
//     

int CFinance::staticCountProcess = 0;
bool CFinance::staticStopProcess = false;

IMPLEMENT_DYNAMIC(CFinance, CWnd)
CFinance::CFinance()
: m_Money(0)
{
}

CFinance::~CFinance()
{
	Util_DeleteGdiObject(&m_Bmp);
}


BEGIN_MESSAGE_MAP(CFinance, CWnd)
END_MESSAGE_MAP()



//    
void CFinance::SetPos(const int& x, const int& y)
{
	SetWindowPos(&CWnd::wndBottom, x, y, 0, 0, SWP_NOSIZE);
}

BOOL CFinance::InitFinance(UINT id_rgn, UINT id_bmp, CWnd* pParent)
{
	m_Bmp.LoadBitmap(id_bmp);
	BITMAP bmp;
	m_Bmp.GetBitmap(&bmp);
	m_Size.cx = bmp.bmWidth;
	m_Size.cy = bmp.bmHeight;
	BOOL result = Create(NULL, NULL, WS_CHILD|WS_CLIPSIBLINGS, CRect(0,0,m_Size.cx,m_Size.cy), pParent, 0);
	
	CRgn rgn;
	CreateCustomRgn(&rgn, id_rgn);
	SetWindowRgn(rgn, TRUE);

	m_Label.InitText(this);
	m_Label.SetFontText(16, "Arial", 600);
	m_Label.SetColorText(RGB(255,255,255));
	m_Label.ShowText(true);
	m_Label.SetPos(m_Size.cx/2, m_Size.cy/2 - 5, 1);
	SetMoney(0);

	return result;
}

void CFinance::SetMoney(const int& number_money, UINT id_bmp[], const int& arr_size)
{
	m_Money = number_money;
	CString s;
	s.Format("%d", m_Money);
	s += ".";
	m_Label.SetText(s);
}

BOOL CFinance::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	//HBRUSH br = CreateSolidBrush(RGB(255,0,0));
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), NULL, NULL);
}

void CFinance::Show(bool show)
{
	show == true ? ShowWindow(SW_SHOW) : ShowWindow(SW_HIDE);

}


////////////////////////////////////////////////////////////
//  

UINT BANKANIM(LPVOID pParam)
{
	CFinance::staticCountProcess++;

	CBankGame* pBankGame = (CBankGame*)pParam;

	if(CBankGame::staticStopProcess == false)
	{
		pBankGame->m_Anim = true;
		CRgn rgn[2];
		CreateCustomRgn(&rgn[0], IDR_BINARY_BANK2);
		CreateCustomRgn(&rgn[1], IDR_BINARY_BANK);

		CBitmap bmp;
		bmp.LoadBitmap(IDB_BITMAP_BANK2);

		CDC* pDC = pBankGame->GetDC();

		pBankGame->SetWindowRgn(rgn[0], TRUE);
		pDC->DrawState(CPoint(0, 0), pBankGame->m_Size, &bmp, DST_BITMAP);
	
		
		Sleep(150);

		pBankGame->SetWindowRgn(rgn[1], TRUE);
		pBankGame->m_Anim = false;
		pBankGame->Invalidate();

		pBankGame->ReleaseDC(pDC);
	}// if(CFinance::staticStopProcess == false)

	CFinance::staticCountProcess--;

	return 0;
}


IMPLEMENT_DYNAMIC(CBankGame, CWnd)
CBankGame::CBankGame()
: m_Anim(false)
{
}

CBankGame::~CBankGame()
{
	
}


BEGIN_MESSAGE_MAP(CBankGame, CWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()



//       


BOOL CBankGame::InitBankGame(CWnd* pParent)
{
	BOOL result = InitFinance(IDR_BINARY_BANK, IDB_BITMAP_BANK, pParent);
	Show(true);

	return result;
}

void CBankGame::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	
	if(m_Anim == false)
	{
		dc.DrawState(CPoint(0,0), m_Size, &m_Bmp, DST_BITMAP);
		m_Label.Draw(&dc);
	}
	// Do not call CWnd::OnPaint() for painting messages
}

void CBankGame::BankGameAnim(void)
{
	AfxBeginThread(BANKANIM, this);
}


///////////////////////////////////////////////////////////////////
//  
CBankPlayer::CBankPlayer(void)
{
}

CBankPlayer::~CBankPlayer(void)
{
}

BOOL CBankPlayer::InitBankPlayer(CWnd* pParent)
{
	//BOOL result = InitFinance(IDR_BINARY_POT0, IDB_BITMAP_POT0, pParent);
	BOOL result = Create("", "", 0, CRect(0,0,68,60), pParent, 5);

	return result;
}
BEGIN_MESSAGE_MAP(CBankPlayer, CFinance)
	ON_WM_PAINT()
END_MESSAGE_MAP()

void CBankPlayer::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	
	dc.DrawState(CPoint(0,0), m_Size, &m_Bmp, DST_BITMAP);
	//m_MyLabel.SetDC(&dc);

	// Do not call CFinance::OnPaint() for painting messages
}

void CBankPlayer::SetMoney(const int& number_money)
{
	const int arr_size = 53;
	UINT id_bmp[arr_size] = 
	{	
		IDB_BITMAP_POT0,	
		IDB_BITMAP_POT10,	IDB_BITMAP_POT20,	IDB_BITMAP_POT30,	IDB_BITMAP_POT40,	IDB_BITMAP_POT50, 
		IDB_BITMAP_POT60,	IDB_BITMAP_POT70,	IDB_BITMAP_POT80,	IDB_BITMAP_POT90,	IDB_BITMAP_POT100,	// 11
		IDB_BITMAP_POT110,	IDB_BITMAP_POT120,	IDB_BITMAP_POT130,	IDB_BITMAP_POT140,	IDB_BITMAP_POT150,	
		IDB_BITMAP_POT160,	IDB_BITMAP_POT170,	IDB_BITMAP_POT180,	IDB_BITMAP_POT190,	IDB_BITMAP_POT200,	
		IDB_BITMAP_POT210,	IDB_BITMAP_POT220,

		IDB_BITMAP_POT240,	IDB_BITMAP_POT260,	IDB_BITMAP_POT280,	IDB_BITMAP_POT300,
		IDB_BITMAP_POT320,	IDB_BITMAP_POT340,	IDB_BITMAP_POT360,	IDB_BITMAP_POT380,	// 14
		IDB_BITMAP_POT400,
		
		IDB_BITMAP_POT420,  IDB_BITMAP_POT460,	IDB_BITMAP_POT500,	IDB_BITMAP_POT540,	IDB_BITMAP_POT580,
		IDB_BITMAP_POT620,  IDB_BITMAP_POT660,	IDB_BITMAP_POT700,	IDB_BITMAP_POT740,	IDB_BITMAP_POT780,	
		IDB_BITMAP_POT800,
		
		IDB_BITMAP_POT820,	IDB_BITMAP_POT860,	IDB_BITMAP_POT900,	IDB_BITMAP_POT940,	IDB_BITMAP_POT980,
		IDB_BITMAP_POT1020, IDB_BITMAP_POT1060,	IDB_BITMAP_POT1100,	IDB_BITMAP_POT1140,	IDB_BITMAP_POT1200	// 20
	};
	UINT id_rgn[arr_size] = 
	{	
		IDR_BINARY_POT0,   
		IDR_BINARY_POT10,	IDR_BINARY_POT20,	IDR_BINARY_POT30,	IDR_BINARY_POT40,	IDR_BINARY_POT50,	
		IDR_BINARY_POT60,   IDR_BINARY_POT70,	IDR_BINARY_POT80,	IDR_BINARY_POT90,	IDR_BINARY_POT100,
		IDR_BINARY_POT110,	IDR_BINARY_POT120,	IDR_BINARY_POT130,	IDR_BINARY_POT140,	IDR_BINARY_POT150,
		IDR_BINARY_POT160,	IDR_BINARY_POT170,	IDR_BINARY_POT180,	IDR_BINARY_POT190,	IDR_BINARY_POT200,	
		IDR_BINARY_POT210,	IDR_BINARY_POT220,  
		
		IDR_BINARY_POT240,	IDR_BINARY_POT260,	IDR_BINARY_POT280,	IDR_BINARY_POT300,	
		IDR_BINARY_POT320,	IDR_BINARY_POT340,	IDR_BINARY_POT360,	IDR_BINARY_POT380, 

		IDR_BINARY_POT400,
		
		IDR_BINARY_POT420,  IDR_BINARY_POT460,	IDR_BINARY_POT500,	IDR_BINARY_POT540,	IDR_BINARY_POT580,	
		IDR_BINARY_POT620,  IDR_BINARY_POT660,	IDR_BINARY_POT700,	IDR_BINARY_POT740,	IDR_BINARY_POT780,

		IDR_BINARY_POT800,

		IDR_BINARY_POT820,	IDR_BINARY_POT860,	IDR_BINARY_POT900,	IDR_BINARY_POT940,	IDR_BINARY_POT980, 
		IDR_BINARY_POT1020, IDR_BINARY_POT1060,	IDR_BINARY_POT1100,	IDR_BINARY_POT1140,	IDR_BINARY_POT1200
	};
	

	m_Money = number_money;
	
	CRgn rgn;
	switch(number_money)
	{
	//  10
	case 0:
		m_IDCurrentBmp = id_bmp[0];
		CreateCustomRgn(&rgn, id_rgn[0]);
		break;
	case 10:
		m_IDCurrentBmp = id_bmp[1];
		CreateCustomRgn(&rgn, id_rgn[1]);
		break;
	case 20: 
		m_IDCurrentBmp = id_bmp[2];
		CreateCustomRgn(&rgn, id_rgn[2]);
		break;
	case 30:
		m_IDCurrentBmp = id_bmp[3];
		CreateCustomRgn(&rgn, id_rgn[3]);
		break;
	case 40:
		m_IDCurrentBmp = id_bmp[4];
		CreateCustomRgn(&rgn, id_rgn[4]);
		break;
	case 50:
		m_IDCurrentBmp = id_bmp[5];
		CreateCustomRgn(&rgn, id_rgn[5]);
		break;
	case 60:
		m_IDCurrentBmp = id_bmp[6];
		CreateCustomRgn(&rgn, id_rgn[6]);
		break;
	case 70:
		m_IDCurrentBmp = id_bmp[7];
		CreateCustomRgn(&rgn, id_rgn[7]);
		break;
	case 80:
		m_IDCurrentBmp = id_bmp[8];
		CreateCustomRgn(&rgn, id_rgn[8]);
		break;
	case 90:
		m_IDCurrentBmp = id_bmp[9];
		CreateCustomRgn(&rgn, id_rgn[9]);
		break;
	case 100:
		m_IDCurrentBmp = id_bmp[10];
		CreateCustomRgn(&rgn, id_rgn[10]);
		break;
	case 110:
		m_IDCurrentBmp = id_bmp[11];
		CreateCustomRgn(&rgn, id_rgn[11]);
		break;
	case 120:
		m_IDCurrentBmp = id_bmp[12];
		CreateCustomRgn(&rgn, id_rgn[12]);
		break;
	case 130:
		m_IDCurrentBmp = id_bmp[13];
		CreateCustomRgn(&rgn, id_rgn[13]);
		break;
	case 140:
		m_IDCurrentBmp = id_bmp[14];
		CreateCustomRgn(&rgn, id_rgn[14]);
		break;
	case 150:
		m_IDCurrentBmp = id_bmp[15];
		CreateCustomRgn(&rgn, id_rgn[15]);
		break;
	case 160:
		m_IDCurrentBmp = id_bmp[16];
		CreateCustomRgn(&rgn, id_rgn[16]);
		break;
	case 170:
		m_IDCurrentBmp = id_bmp[17];
		CreateCustomRgn(&rgn, id_rgn[17]);
		break;
	case 180:
		m_IDCurrentBmp = id_bmp[18];
		CreateCustomRgn(&rgn, id_rgn[18]);
		break;
	case 190:
		m_IDCurrentBmp = id_bmp[19];
		CreateCustomRgn(&rgn, id_rgn[19]);
		break;
	case 200:
		m_IDCurrentBmp = id_bmp[20];
		CreateCustomRgn(&rgn, id_rgn[20]);
		break;
	case 210:
		m_IDCurrentBmp = id_bmp[21];
		CreateCustomRgn(&rgn, id_rgn[21]);
		break;
	case 220:
		m_IDCurrentBmp = id_bmp[22];
		CreateCustomRgn(&rgn, id_rgn[22]);
		break;

		//  20
	case 230:
	case 240:
		m_IDCurrentBmp = id_bmp[23];
		CreateCustomRgn(&rgn, id_rgn[23]);
		break;
	case 250:
	case 260:
		m_IDCurrentBmp = id_bmp[24];
		CreateCustomRgn(&rgn, id_rgn[24]);
		break;
	case 270:
	case 280:
		m_IDCurrentBmp = id_bmp[25];
		CreateCustomRgn(&rgn, id_rgn[25]);
		break;
	case 290:
	case 300:
		m_IDCurrentBmp = id_bmp[26];
		CreateCustomRgn(&rgn, id_rgn[26]);
		break;
	case 310:
	case 320:
		m_IDCurrentBmp = id_bmp[27];
		CreateCustomRgn(&rgn, id_rgn[27]);
		break;
	case 330:
	case 340:
		m_IDCurrentBmp = id_bmp[28];
		CreateCustomRgn(&rgn, id_rgn[28]);
		break;
	case 350:
	case 360:
		m_IDCurrentBmp = id_bmp[29];
		CreateCustomRgn(&rgn, id_rgn[29]);
		break;
	case 370:
	case 380:
	case 390:
		m_IDCurrentBmp = id_bmp[30];
		CreateCustomRgn(&rgn, id_rgn[30]);
		break;
	case 400:
		m_IDCurrentBmp = id_bmp[31];
		CreateCustomRgn(&rgn, id_rgn[31]);
		break;
	case 410:
	case 420:
		m_IDCurrentBmp = id_bmp[32];
		CreateCustomRgn(&rgn, id_rgn[32]);
		break;
		
		//  40
	case 430:
	case 440:
	case 450:
	case 460:
		m_IDCurrentBmp = id_bmp[33];
		CreateCustomRgn(&rgn, id_rgn[33]);
		break;
	case 470:
	case 480:
	case 490:
	case 500:
		m_IDCurrentBmp = id_bmp[34];
		CreateCustomRgn(&rgn, id_rgn[34]);
		break;
	case 510:
	case 520:
	case 530:
	case 540:
		m_IDCurrentBmp = id_bmp[35];
		CreateCustomRgn(&rgn, id_rgn[35]);
		break;
	case 550:
	case 560:
	case 570:
	case 580:
		m_IDCurrentBmp = id_bmp[36];
		CreateCustomRgn(&rgn, id_rgn[36]);
		break;
	case 590:
	case 600:
	case 610:
	case 620:
		m_IDCurrentBmp = id_bmp[37];
		CreateCustomRgn(&rgn, id_rgn[37]);
		break;
	case 630:
	case 640:
	case 650:
	case 660:
		m_IDCurrentBmp = id_bmp[38];
		CreateCustomRgn(&rgn, id_rgn[38]);
		break;
	case 670:
	case 680:
	case 690:
	case 700:
		m_IDCurrentBmp = id_bmp[39];
		CreateCustomRgn(&rgn, id_rgn[39]);
		break;
	case 710:
	case 720:
	case 730:
	case 740:
		m_IDCurrentBmp = id_bmp[40];
		CreateCustomRgn(&rgn, id_rgn[40]);
		break;
	case 750:
	case 760:
	case 770:
	case 780:
	case 790:
		m_IDCurrentBmp = id_bmp[41];
		CreateCustomRgn(&rgn, id_rgn[41]);
		break;
	case 800:
		m_IDCurrentBmp = id_bmp[42];
		CreateCustomRgn(&rgn, id_rgn[42]);
		break;
	case 810:
	case 820:
		m_IDCurrentBmp = id_bmp[43];
		CreateCustomRgn(&rgn, id_rgn[43]);
		break;
	case 830:
	case 840:
	case 850:
	case 860:
		m_IDCurrentBmp = id_bmp[44];
		CreateCustomRgn(&rgn, id_rgn[44]);
		break;
	case 870:
	case 880:
	case 890:
	case 900:
		m_IDCurrentBmp = id_bmp[45];
		CreateCustomRgn(&rgn, id_rgn[45]);
		break;
	case 910:
	case 920:
	case 930:
	case 940:
		m_IDCurrentBmp = id_bmp[46];
		CreateCustomRgn(&rgn, id_rgn[46]);
		break;
	case 950:
	case 960:
	case 970:
	case 980:
		m_IDCurrentBmp = id_bmp[47];
		CreateCustomRgn(&rgn, id_rgn[47]);
		break;
	case 990:
	case 1000:
	case 1010:
	case 1020:
		m_IDCurrentBmp = id_bmp[48];
		CreateCustomRgn(&rgn, id_rgn[48]);
		break;
	case 1030:
	case 1040:
	case 1050:
	case 1060:
		m_IDCurrentBmp = id_bmp[49];
		CreateCustomRgn(&rgn, id_rgn[49]);
		break;
	case 1070:
	case 1080:
	case 1090:
	case 1100:
	case 1110:
	case 1120:
	case 1130:
		m_IDCurrentBmp = id_bmp[50];
		CreateCustomRgn(&rgn, id_rgn[50]);
		break;
	case 1140:
	case 1150:
	case 1160:
	case 1170:
	case 1180:
	case 1190:
		m_IDCurrentBmp = id_bmp[51];
		CreateCustomRgn(&rgn, id_rgn[51]);
		break;
	
	
	//  
	case 1200:
		m_IDCurrentBmp = id_bmp[52];
		CreateCustomRgn(&rgn, id_rgn[52]);
		break;
	default:
		m_IDCurrentBmp = id_bmp[0];
		CreateCustomRgn(&rgn, id_rgn[0]);
		break;
	}

	Util_DeleteGdiObject(&m_Bmp);
	m_Bmp.LoadBitmap(m_IDCurrentBmp);
	BITMAP bmp;
	m_Bmp.GetBitmap(&bmp);
	m_Size.cx = bmp.bmWidth;
	m_Size.cy = bmp.bmHeight;
	
	SetWindowRgn(rgn, TRUE);
	Invalidate();
}
