#include "StdAfx.h"
#include "nine.h"
#include ".\custommenu.h"




CCustomMenu::CCustomMenu(void)
{
}

CCustomMenu::~CCustomMenu(void)
{
	//     
	for(int i = 0; i < (int)m_ItemsData.size(); i++)
		DELETEPOINT(m_ItemsData[i]);

	//  
	m_ItemsData.clear();
}


void CCustomMenu::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	ITEMDATA* pItemData = (ITEMDATA*)lpDrawItemStruct->itemData; 

	// --   	--
	CFont font;
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight = 20;                  
	strcpy(lf.lfFaceName, "Microsoft Sans Serif"); //"Courier New");   
	lf.lfWeight = FW_DONTCARE;
	lf.lfCharSet = RUSSIAN_CHARSET;
	font.CreatePointFontIndirect(&lf);
	CFont* pOldFont = pDC->SelectObject(&font);
	pDC->SetBkMode(TRANSPARENT);
	
	//     
	CRect rc(&lpDrawItemStruct->rcItem);

	//     
	CBrush brush(GetSysColor(COLOR_WINDOW/*COLOR_BTNFACE*/));
	CBrush* pOldBrush = pDC->SelectObject(&brush);
	
	//      
	if ((lpDrawItemStruct->itemAction & ODA_DRAWENTIRE) == ODA_DRAWENTIRE)
	{
		//  :
		//      -     ,
		//     -  
		if(pItemData != NULL)
		{
			pDC->FillRect(&rc, &brush);
			rc.InflateRect(-11, 0, 11, 0);
			pDC->SetTextColor(pItemData->color);

			//      -
			//    
			if((lpDrawItemStruct->itemState &  ODS_DISABLED) == ODS_DISABLED)
				pDC->SetTextColor(GetSysColor(COLOR_GRAYTEXT));

			pDC->DrawText((LPCTSTR)pItemData->text, &rc, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
		}
		else
		{
			CPen pen(0, 1, RGB(150,150,150));
			CPen* pOldPen =  pDC->SelectObject(&pen);
			pDC->MoveTo(lpDrawItemStruct->rcItem.left,lpDrawItemStruct->rcItem.top + 
						(lpDrawItemStruct->rcItem.bottom - lpDrawItemStruct->rcItem.top)/2);
			pDC->LineTo(lpDrawItemStruct->rcItem.right, lpDrawItemStruct->rcItem.top + 
						(lpDrawItemStruct->rcItem.bottom - lpDrawItemStruct->rcItem.top)/2);
			pDC->SelectObject(pOldPen);
		}
		   
	}
	
	//   (   )       
	if ((lpDrawItemStruct->itemState & ODS_SELECTED) && (lpDrawItemStruct->itemAction & (ODA_SELECT | ODA_DRAWENTIRE)))
	{
		if(pItemData != NULL)
		{
			if((lpDrawItemStruct->itemState &  ODS_DISABLED) != ODS_DISABLED)
			{
				pDC->FillRect(&rc, &CBrush(RGB(0,0,255)));
				rc.InflateRect(-11, 0, 11, 0);
				pDC->SetTextColor(RGB(255,255,255));
				pDC->DrawText((LPCTSTR)pItemData->text, &rc, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
			}
		}
	}

	//    (     )      
	if(!(lpDrawItemStruct->itemState & ODS_SELECTED) && (lpDrawItemStruct->itemAction & ODA_SELECT))
	{
		if(pItemData != NULL)
		{
			pDC->FillRect(&rc, &brush);
			rc.InflateRect(-11, 0, 11, 0);
			pDC->SetTextColor(pItemData->color);

			//      -
			//    
			if((lpDrawItemStruct->itemState &  ODS_DISABLED) == ODS_DISABLED)
				pDC->SetTextColor(GetSysColor(COLOR_GRAYTEXT));

			pDC->DrawText((LPCTSTR)pItemData->text, &rc, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
		}
	}

	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldFont);
}

//      -    ,
//      -    
void CCustomMenu::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	lpMeasureItemStruct->itemWidth = 90;

	if(lpMeasureItemStruct->itemData == 0)
		lpMeasureItemStruct->itemHeight = 5;
	else
		lpMeasureItemStruct->itemHeight = 20;
	
}

//      ,    
void CCustomMenu::AppendMenu(const UINT& id_command, LPCTSTR text_menu, COLORREF color, bool enabled)
{
	//           
	ITEMDATA* pitem_data = new ITEMDATA;
	m_ItemsData.push_back(pitem_data);
	
	strcpy(pitem_data->text, text_menu);
	pitem_data->color = color;
	
	UINT flag = 0;
	if(enabled == true)
		flag |= MF_STRING|MF_OWNERDRAW;
	else
		flag |= MF_STRING|MF_OWNERDRAW|MF_DISABLED;

	CMenu::AppendMenu(flag, id_command, (LPCTSTR)pitem_data);
}

//    
void CCustomMenu::AppendSeparator(void)
{
	CMenu::AppendMenu(MF_SEPARATOR|MF_OWNERDRAW);
}

