#include "StdAfx.h"
#include ".\decoration.h"



CDecoration::CDecoration(void)
: m_pParent(NULL)
, m_NUMBERPLAYERS(0)
, m_numberBGGames(1)
, m_numberTableGames(2)
, m_pAdjustment(NULL)
, m_maxMoney(0)
, m_RateGame(500)
, m_DifficultGame(false)
, m_numberShirt(1)
, m_RequestName(false)
, m_Sound(false)
, m_pMessageBox(NULL)
, m_ChatVisible(false)
{
}

CDecoration::~CDecoration(void)
{
	DELETEPOINT(m_pAdjustment);
	DELETEPOINT(m_pMessageBox);
	Util_DeleteGdiObject(&m_BrushBG);
}


void CDecoration::InitDecoration(CWnd* pParent, bool net_game)
{
	m_pParent = pParent;
	
	if(m_NUMBERPLAYERS == 0)
		AfxMessageBox("      CDecoration::SetParent");

	for(int i = 0; i < MAXPLAYERS; i++)
	{
		m_Player[i].SetParent(m_pParent);
	}

	m_Money.InitMoney(m_pParent);

	for(int i = 0; i < m_NUMBERPLAYERS; i++)
	{
		m_Player[i].Show(true);
	}

	m_Pack.InitPack36(m_pParent);

	//    (     ) 
	m_dlgUserName.m_NetDlg = net_game;
	

	m_pAdjustment = new CAdjustment("", m_pParent);
	//    (     ) 
	m_pAdjustment->m_PagePublicSetting.m_NetGame = net_game;
	m_pAdjustment->Create(m_pParent, WS_SYSMENU|DS_MODALFRAME);
	m_pAdjustment->SetActivePage(1);
	m_pAdjustment->SetActivePage(0);

	m_BankGame.InitBankGame(m_pParent);

	m_pMessageBox = new CMessageBox(m_pParent);

	//   
	m_mainLabel.InitText(m_pParent);
	m_mainLabel.SetColorText(RGB(255,255,255));
	m_mainLabel.SetFontText(-20, "Times New Roman", FW_NORMAL);
	m_mainLabel.SetShade(true);
	m_mainLabel.ShowText(true);
}

//    
void CDecoration::SetBGGame(CDC* pDC, const int& number_bg)
{
	ASSERT(m_pParent != NULL);
	
	CRect rc_Parent;
	m_pParent->GetClientRect(&rc_Parent);

	CBrush* pOldBrush = pDC->SelectObject(&m_BrushBG);
	pDC->Rectangle(&CRect(rc_Parent.left-1, rc_Parent.top-1, rc_Parent.right+1, rc_Parent.bottom+1));
	pDC->SelectObject(pOldBrush);
}


//   
void CDecoration::SetTableGame(CDC* pDC, const int& number_table)
{
	CBitmap bmp;
	CBrush brush_frame;

	switch(number_table)
	{
	case 1:
		break;
	case 2:
		{
			CBrush brush(RGB(160,220,160));
			CRect rc;

			for(int j = 0; j < 4; j++)
				for(int i = 0; i < 9; i++)
				{
					rc.SetRect(CPoint(m_ptCoordinateTable[j][i].x-1, m_ptCoordinateTable[j][i].y-1), 
						CPoint(m_ptCoordinateTable[j][i].x + GetTableCardSize().cx+2, 
						m_ptCoordinateTable[j][i].y + GetTableCardSize().cy+2));

					CRgn rgn;
					rgn.CreateRoundRectRgn(rc.left, rc.top, rc.right, rc.bottom, 6, 6);
					pDC->FrameRgn(&rgn, &brush, 1, 1);
				}

			
		}
		break;
	case 3:
		{
			CFont font;
			font.CreatePointFont(300, "Times New Roman");
			CFont* pOldFont = pDC->SelectObject(&font);

			CBrush brush(RGB(160,220,160));
			CRect rc;

			for(int j = 0; j < 4; j++)
				for(int i = 0; i < 9; i++)
				{
					rc.SetRect(CPoint(m_ptCoordinateTable[j][i].x-1, m_ptCoordinateTable[j][i].y-1), 
						CPoint(m_ptCoordinateTable[j][i].x + GetTableCardSize().cx+2, 
						m_ptCoordinateTable[j][i].y + GetTableCardSize().cy+2));

					CRgn rgn;
					rgn.CreateRoundRectRgn(rc.left, rc.top, rc.right, rc.bottom, 6, 6);
					pDC->FrameRgn(&rgn, &brush, 1, 1);

					int old_mode = pDC->GetBkMode();
					COLORREF old_color = pDC->GetTextColor();

					pDC->SetBkMode(TRANSPARENT);
					pDC->SetTextColor(RGB(160,220,160));

					CString name_card;
					name_card = IntToStr(i+6);
					switch(i+6)
					{
					case 11:
						name_card = "";
						break;
					case 12:
						name_card = "";
						break;
					case 13:
						name_card = "";
						break;
					case 14:
						name_card = "";
						break;
					}

					pDC->DrawText(name_card, &rc, DT_CENTER|DT_VCENTER|DT_SINGLELINE);

					pDC->SetBkMode(old_mode);
					pDC->SetTextColor(old_color);
				}

				pDC->SelectObject(pOldFont);
		}
		break;
	case 4:
		{
			bmp.LoadBitmap(IDB_BITMAP_TAB1);
			brush_frame.CreatePatternBrush(&bmp);

			CRect rc;
			rc.SetRect(m_ptCoordinateTable[0][0], 
				CPoint(m_ptCoordinateTable[3][8].x+GetTableCardSize().cx, m_ptCoordinateTable[3][8].y+GetTableCardSize().cy));

			CRgn rgn;
			rgn.CreateRoundRectRgn(rc.left, rc.top, rc.right, rc.bottom, 6, 6);
			pDC->FillRgn(&rgn, &brush_frame);
		}
		break;
	case 5:
		{
			bmp.LoadBitmap(IDB_BITMAP_TAB2);
			brush_frame.CreatePatternBrush(&bmp);

			CRect rc;
			rc.SetRect(m_ptCoordinateTable[0][0], 
				CPoint(m_ptCoordinateTable[3][8].x+GetTableCardSize().cx, m_ptCoordinateTable[3][8].y+GetTableCardSize().cy));

			CRgn rgn;
			rgn.CreateRoundRectRgn(rc.left, rc.top, rc.right, rc.bottom, 6, 6);
			pDC->FillRgn(&rgn, &brush_frame);
		}
		break;
	case 6:
		{
			bmp.LoadBitmap(IDB_BITMAP_TAB3);
			brush_frame.CreatePatternBrush(&bmp);

			CRect rc;
			rc.SetRect(m_ptCoordinateTable[0][0], 
				CPoint(m_ptCoordinateTable[3][8].x+GetTableCardSize().cx, m_ptCoordinateTable[3][8].y+GetTableCardSize().cy));

			CRgn rgn;
			rgn.CreateRoundRectRgn(rc.left, rc.top, rc.right, rc.bottom, 6, 6);
			pDC->FillRgn(&rgn, &brush_frame);
		}
		break;
	case 7:
		CRect rc;
		rc.SetRect(m_ptCoordinateTable[0][0], 
			CPoint(m_ptCoordinateTable[3][8].x+GetTableCardSize().cx, m_ptCoordinateTable[3][8].y+GetTableCardSize().cy));
		pDC->SelectClipRgn(NULL);
		
		//    -        ,
		//  -   -   
		if(m_TableImage.DrawImage(pDC->GetSafeHdc(), rc) == S_OK) 
		{
			pDC->FrameRect(&rc, &CBrush(RGB(255,255,0)));
		}
		else
		{
			m_numberTableGames = 1;
			m_pParent->Invalidate();
		}
		
		break;
	}
}

//         
SIZE CDecoration::GetTableCardSize(void)
{
	return m_SizeCard;
}

//     
void CDecoration::SetTableCoordinate(void)
{
	CRect rc;
	m_pParent->GetClientRect(&rc);
	POINT pt;
	int offset_x = m_SizeCard.cx + 4;
	int offset_y = m_SizeCard.cy + 4;
	int center_x = rc.right/2;
	int center_y = rc.bottom/2;


	for(int m = 1; m <= 4; m++)
		for(int v = 1; v <= 9; v++)
		{
			int first_x = center_x - ((9-1)/2)*offset_x - m_SizeCard.cx/2;
			int first_y = center_y - (4/2)*offset_y;
			pt.x = first_x + offset_x*(v - 1);
			pt.y = first_y + offset_y*(m - 1);

			if(m == 1 || m == 2)
				pt.y -= 12;
			else
				pt.y += 12;
		
			m_ptCoordinateTable[m-1][v-1] = pt;
		}

		for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)
		{
			if(m_Pack.GetCard(i)->m_State == CPack::StateCards::m_eTable)
			{
				m_Pack.GetCard(i)->SetCardPos(m_ptCoordinateTable[m_Pack.GetCard(i)->m_Mast-1][m_Pack.GetCard(i)->m_Value-1]);
				m_Pack.GetCard(i)->SetWindowPos(&CWnd::wndBottom, 0,0,
					GetTableCardSize().cx, GetTableCardSize().cy,SWP_NOMOVE);
				m_Pack.GetCard(i)->ResetCardSize(GetTableCardSize().cx, GetTableCardSize().cy);
			}
		}

}

void CDecoration::OnSize(const int& cx, const int& cy)
{
	//          
	//     
	//          
	//   DefWindowPos
	if(cx < 740 || cy < 530)
	{
		m_SizeCard.cx = 50;
		m_SizeCard.cy = 63;
	}
	else if( (cx >= 740 && cx < 840) || (cy >= 530 && cy < 590) )
	{
		m_SizeCard.cx = 60;
		m_SizeCard.cy = 81;
	}
	else
	{
		m_SizeCard.cx = 71;
		m_SizeCard.cy = 96;
	}
	SetTableCoordinate();

	switch(m_NUMBERPLAYERS)
	{
	case 1:
		{
			//      
			CPoint pt(cx/2 - cx/3.8, cy-96);
			m_Player[0].SetPos(pt);
		}
		break;
	case 2:
		{
			CPoint pt(cx/2 - cx/3.8, cy - 96);
			m_Player[0].SetPos(pt);
			pt.y = 2;
			m_Player[1].SetPos(pt);
			break;
		}
	case 3:
		{
			CPoint pt(cx/2 - cx/3.8, cy-96);
			m_Player[0].SetPos(pt);
			pt.SetPoint(55, cy/2 - cy/2.3);
			m_Player[1].SetPos(pt);
			pt.x = cx - 55;
			m_Player[2].SetPos(pt);
			break;
		}
	case 4:
		{
			CPoint pt(cx/2 - cx/3.8, cy-96);
			m_Player[0].SetPos(pt);
			pt.SetPoint(cx/2 - cx/4, 2);
			m_Player[2].SetPos(pt);

			pt.SetPoint(55, cy/2 - cy/2.3);
			m_Player[1].SetPos(pt);
			pt.x = cx - 55;
			m_Player[3].SetPos(pt);
			
			break;
		}
	
	}// switch(m_NUMBERPLAYERS)



	for(int p = 0; p < m_NUMBERPLAYERS; p++)
	{
		RightPlayerCards(p + 1);
	}

	m_BankGame.SetPos(10, cy - 54);
}

//     
POINT CDecoration::GetTableCardsPos(const int& mast, const int& value)
{
	return m_ptCoordinateTable[mast-1][value-1];
}

//       
POINT CDecoration::GetPlayersCardPos(const int& player, const int& number_cards, const int& card_pos)
{
	ASSERT(m_NUMBERPLAYERS != 0);

	if(number_cards == 0) return CPoint(0,0);

	CRect rc;
	m_pParent->GetClientRect(&rc);
	POINT pt;
	int offset = 0;
	int k = 0;
	
	int offset_horizontally = 80;
	int x = m_Player[player-1].m_ptPos.x + offset_horizontally;
	int width_pos = rc.Width() - x*2;

	int offset_vertically = 140;
	int y = m_Player[1].m_ptPos.y + offset_vertically;
	int height_pos = rc.Height() - y*2;

	if(m_NUMBERPLAYERS == 4)
	{
		if(player == 1)
		{
			pt.y = rc.bottom - CARDHEIGHT - 2;
			pt.x = x + (width_pos/number_cards)*(card_pos) - (CARDWIDTH-width_pos/number_cards)/2;
		}
		if(player == 2)
		{
			pt.y = y + (height_pos/number_cards)*(card_pos) - (CARDHEIGHT-height_pos/number_cards)/2;
			pt.x = 2;
		}
		if(player == 3)
		{
			pt.y = 2;
			pt.x = x + (width_pos/number_cards)*(card_pos) - (CARDWIDTH-width_pos/number_cards)/2;
		}
		if(player == 4)
		{
			pt.y = y + (height_pos/number_cards)*(card_pos) - (CARDHEIGHT-height_pos/number_cards)/2;
			pt.x = rc.right - CARDWIDTH - 2;
		}
	}

	if(m_NUMBERPLAYERS == 3)
	{
		if(player == 1)
		{
			pt.y = rc.bottom - CARDHEIGHT - 2;
			pt.x = x + (width_pos/number_cards)*(card_pos) - (CARDWIDTH-width_pos/number_cards)/2;
		}
		if(player == 2)
		{
			pt.y = y + (height_pos/number_cards)*(card_pos) - (CARDHEIGHT-height_pos/number_cards)/2;
			pt.x = 2;
		}
		if(player == 3)
		{
			pt.y = y + (height_pos/number_cards)*(card_pos) - (CARDHEIGHT-height_pos/number_cards)/2;
			pt.x = rc.right - CARDWIDTH - 2;
		}
	}

	if(m_NUMBERPLAYERS == 2)
	{
		if(player == 1)
		{
			pt.y = rc.bottom - CARDHEIGHT - 2;
			pt.x = x + (width_pos/number_cards)*(card_pos) - (CARDWIDTH - width_pos/number_cards)/2;
		}
		if(player == 2)
		{
			pt.y = 2;
			pt.x = x + (width_pos/number_cards)*(card_pos) - (CARDWIDTH - width_pos/number_cards)/2;
		}
		
	}

	if(m_NUMBERPLAYERS == 1)
	{
		if(player == 1)
		{
			pt.y = rc.bottom - CARDHEIGHT - 2;
			pt.x = x + (width_pos/number_cards)*(card_pos) - (CARDWIDTH-width_pos/number_cards)/2;
		}
	}

	if(m_NUMBERPLAYERS < 1)
	{
		pt.x = 100;
		pt.y = 100;
		AfxMessageBox(" -    1!");
	}

	
	return pt;
}

//     
int CDecoration::GetNumberPlayerCards(const int& player)
{
	int count = 0;
	for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer)
			if(m_Pack.GetCard(i)->m_Player == player)
				count++;
	}


	return count;
}

//    
void CDecoration::RightUserCards(void)
{
	CPoint pt[18];
	int pos = 0;
	int card_pos = 0;
	int number_cards = GetNumberPlayerCards(1);
	for(int card = 0; card < m_Pack.GetNumberCardsInPack(); card++)
	{
		if(m_Pack.GetCard(card)->m_State == CPack::StateCards::m_ePlayer)
			if(m_Pack.GetCard(card)->m_Player == 1)
				{
					pt[pos++] = GetPlayersCardPos(1, number_cards, card_pos++);
				}
	}

	int p = 0;
	for(int m = 1; m <= 4; m++)
		for(int card = 0; card < m_Pack.GetNumberCardsInPack(); card++)
		{
			if(m_Pack.GetCard(card)->m_State == CPack::StateCards::m_ePlayer)
				if(m_Pack.GetCard(card)->m_Player == 1)
					if(m_Pack.GetCard(card)->m_Mast == m)
					{
						m_Pack.GetCard(card)->SetCardPos(pt[p++]);
						m_Pack.GetCard(card)->BringWindowToTop();
						
					}
		}

}

//    
void CDecoration::RightPlayerCards(const int& player)
{
	if(player == 1)
	{
		RightUserCards();
		return;
	}

	int card_pos = 0;
	int number_cards = GetNumberPlayerCards(player);
	for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)
	{
		if(m_Pack.GetCard(i)->m_State == CPack::StateCards::m_ePlayer)
		{
			if(m_Pack.GetCard(i)->m_Player == player)
			{
				m_Pack.GetCard(i)->SetCardPos(GetPlayersCardPos(player, number_cards, card_pos++));
			}
		}
	}// for(int i = 0; i < m_Decoration.m_Pack.GetNumberCardsInPack(); i++)

}

void CDecoration::DoDistr(const int& distr_player)
{
	ASSERT(m_NUMBERPLAYERS != 0);

	int player = distr_player;
	int number_player = m_NUMBERPLAYERS;
	int card_pos = 0;
	int countplayer = 0;
	int number_cards = 36/number_player;
	while( card_pos < number_cards )
	{
		int index = 0;
		CCard* temp  = m_Pack.TakeCard(&index);

		if(temp == NULL)
			break;

		temp->BringWindowToTop();
		temp->m_State = CPack::StateCards::m_ePlayer;

		switch(player)
		{
		case 1:
			temp->m_Player = 1;
			temp->SetCardPos(GetPlayersCardPos(1, 1, 0));
			temp->CardClose(false);
			break;
		case 2:
			temp->m_Player = 2;
			temp->SetCardPos(GetPlayersCardPos(2, 1, 0));
			break;
		case 3:
			temp->m_Player = 3;
			temp->SetCardPos(GetPlayersCardPos(3, 1, 0));
			break;
		case 4:
			temp->m_Player = 4;
			temp->SetCardPos(GetPlayersCardPos(4, 1, 0));
			break;
		}


		//   ..    
		player++;
		if(player > number_player)
			player = 1;

		countplayer++;

		if(countplayer == number_player)
		{
			card_pos++;
			countplayer = 0;
		}

	}//while( numbercards != 3/*   3  */)

	for(int i = 1; i <= 4; i++)
		RightPlayerCards(i);
}

//      4        
bool CDecoration::Check4Nine4Tuz(void)
{
	
	//        
	//       4   4 ,
	//        
	CCard* tuz[4][4]  = {NULL};
	CCard* nine[4][4] = {NULL};

	for(int p = 0; p < m_NUMBERPLAYERS; p++)
	{
		char count_tuz = 0;
		char count_nine = 0;
		for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)
		{
			if(m_Pack.GetCard(i)->m_Player == (p+1))
			{
				if(m_Pack.GetCard(i)->m_Value == CPack::m_durakT)
					tuz[p][count_tuz++] = m_Pack.GetCard(i);
				if(m_Pack.GetCard(i)->m_Value == CPack::m_durak9)
					nine[p][count_nine++] = m_Pack.GetCard(i);
			}
		}
	}

	//     4  () 4 
	bool is_4nine = false;
	bool is_4tuz  = false;
	int player_tuz  = 0;
	int player_nine = 0;
	int index = 3; //      
	for(int p = 0; p < m_NUMBERPLAYERS; p++)
	{
		if(tuz[p][index] != NULL)
		{
			player_tuz = tuz[p][0]->m_Player;
			is_4tuz = true;
		}

		if(nine[p][index] != NULL)
		{
			player_nine = nine[p][0]->m_Player;
			is_4nine = true;
		}
	}

	

	CString s;
	if(is_4tuz == true && is_4nine == true)
	{
		//       
		if(player_nine != player_tuz)
		{
			s = "  " + m_Player[player_nine-1].GetName() + "  4 \n  " + 
			m_Player[player_tuz-1].GetName() + "  4 .\n  !";
		}
		else
			s = "  " + m_Player[player_tuz-1].GetName() + "  4   4 !\n  !";
	}
	else if(is_4tuz == true)
	{
		s = "  " + m_Player[player_tuz-1].GetName() + "  4 !\n  !";
	}
	else if(is_4nine == true)
		s = "  " + m_Player[player_nine-1].GetName() + "  4 !\n  !";
	
	if(s.IsEmpty() == false)
	{
		for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)
		{
			if(	player_tuz != 0 &&
				m_Pack.GetCard(i)->m_Player == player_tuz)
				m_Pack.GetCard(i)->CardClose(false);

			if(	player_nine != 0 &&
				m_Pack.GetCard(i)->m_Player == player_nine)
				m_Pack.GetCard(i)->CardClose(false);
		}

		MessageWnd(s, MMB_OK);


		return true;
		
	}

	EndMessageWnd();
		

	return false;
}

//       
void CDecoration::AnimMoneyToBank(const int& player)
{
	CRect rc;
	m_pParent->GetClientRect(&rc);

	m_Money.RotateMoney();
	m_Money.SetMoneyPos(m_Player[player-1].m_ptPos.x - 11, m_Player[player-1].m_ptPos.y + 33);
	m_Money.ShowWindow(SW_SHOW);
	
	m_Money.MoneyMove(m_Player[player-1].m_ptPos.x - 11, m_Player[player-1].m_ptPos.y + 33);

	
	m_Money.MoneyMove(m_Player[player-1].m_ptPos.x - 11, m_Player[player-1].m_ptPos.y - 25);
	m_Money.StopRotate();
	m_Money.MoneyMove(32, rc.bottom - 64);
	m_Money.MoneyMoveSound(32, rc.bottom - 64);


	m_Money.ShowWindow(SW_HIDE);
	m_BankGame.BankGameAnim();

}

//     -
void CDecoration::AnimMoneyToPlayer(const int& player)
{
	m_BankGame.BankGameAnim();
	CRect rc;
	m_pParent->GetClientRect(&rc);
	m_Money.SetMoneyPos(32, rc.bottom - 64);
	m_Money.ShowWindow(SW_SHOW);
	m_Money.MoneyMove(32, rc.bottom - 64);

	m_Money.MoneyMove(m_Player[player-1].m_ptPos.x - 11, m_Player[player-1].m_ptPos.y - 5);
	m_Money.RotateMoney();
	m_Money.MoneyMove(m_Player[player-1].m_ptPos.x - 11, m_Player[player-1].m_ptPos.y + 10);
	
	m_Money.MoneyMoveSound(m_Player[player-1].m_ptPos.x - 11, m_Player[player-1].m_ptPos.y + 33);
	m_Money.StopRotate();
	
	m_Money.ShowWindow(SW_HIDE);
}

void CDecoration::SetDC(CDC* pDC)
{
	if(m_numberTableGames == 7)
	{
		CRect rc;
		rc.SetRect(m_ptCoordinateTable[0][0], 
			CPoint(m_ptCoordinateTable[3][8].x+GetTableCardSize().cx, m_ptCoordinateTable[3][8].y+GetTableCardSize().cy));
		pDC->ExcludeClipRect(&rc);
	}
	
	SetBGGame(pDC, m_numberBGGames);
	SetTableGame(pDC, m_numberTableGames);

	//  
	for(int p = 0; p < m_NUMBERPLAYERS; p++)
	{
		m_Player[p].SetDC(pDC);
	}

}

//   
void CDecoration::SetPlayersName(void)
{
	CNameDlg* dlg = &m_dlgUserName;
	dlg->m_UserNames[0] = m_Player[0].GetName();
	dlg->m_strNameLeft  = m_Player[1].GetName();
	dlg->m_strNameTop   = m_Player[2].GetName();
	dlg->m_strNameRight = m_Player[3].GetName();


	dlg->SetNumberName(m_NUMBERPLAYERS);

	
	CString old_name = dlg->m_UserNames[0];

	//    
	if(dlg->DoModal() == IDOK)
	{
		if(dlg->m_UserNames[0] == old_name) return;

		//     
		CString str[MAXNAMEPLAYERS+1];
		str[0] = dlg->m_UserNames[0];//    
		str[1] = old_name;
		int count = 2;
		for(int i = 1; i < MAXNAMEPLAYERS; i++)
		{
			if( dlg->m_UserNames[i] != dlg->m_UserNames[0] &&
				dlg->m_UserNames[i].IsEmpty() == false)
			{
				str[count] = dlg->m_UserNames[i];
				count++;
			}
		}

		//  
		for(int i = 0; i < MAXNAMEPLAYERS; i++)
		{
			dlg->m_UserNames[i] = str[i];
		}

		m_Player[0].SetName(dlg->m_UserNames[0]);

	}// if(dlg->DoModal() == IDOK)
}


//       .
void CDecoration::SetSound(bool sound)
{
	//     .
	CCard::staticSound = sound;

	//     .
	CMoney::staticSound = sound;
}

//        
LRESULT CDecoration::OnPublicSetting(WPARAM wParam, LPARAM lParam)
{
	switch(wParam)
	{
		//    .
	case IDC_RADIO_MONEY100:
		m_maxMoney = 100;
		break;
	case IDC_RADIO_MONEY200:
		m_maxMoney = 200;
		break;
	case IDC_RADIO_MONEY300:
		m_maxMoney = 300;
		break;
		//   .
	case IDC_SLIDER_RATE:
		m_RateGame = (int)lParam;
		break;

	case IDC_CHECK_ANIM:
		m_Pack.ShowAinmationCards(BOOLTobool((BOOL)lParam));
		break;
		//  .
	case IDC_CHECK_OPENCARDS:
		m_Pack.OpenAllCards(BOOLTobool((BOOL)lParam));
		break;
	case IDC_CHECK_DIFFICULTGAME:
		m_DifficultGame = BOOLTobool((BOOL)lParam);
		break;
	case IDC_CHECK_REQUESTNAME:
		m_RequestName = BOOLTobool((BOOL)lParam);
		break;
	case IDC_CHECK_SOUND:
		m_Sound = BOOLTobool((BOOL)lParam);
		SetSound(m_Sound);
		break;
	case IDC_CHECK_CHAT:
		m_ChatVisible = BOOLTobool((BOOL)lParam);
		break;

		//   
	case IDC_LIST_TABLES:
		if((int)lParam == 1000)
		{
			m_TableImage.LoadFileImage(m_pAdjustment->m_PageView.m_strTableImage);
			//      7  
			//    .
			//        7 
			//      
			m_numberTableGames = 7;
		}
		else
		{
			m_numberTableGames = (int)lParam;
			
		}
		m_pParent->Invalidate();
		break;

		//    
	case IDC_LIST_BG:
		if((int)lParam == 1000)
		{
			Util_DeleteGdiObject(&m_BrushBG);
			m_BrushBG.m_hObject = 
				::CreatePatternBrush((HBITMAP)LoadImage(NULL, m_pAdjustment->m_PageView.m_strBrushBG, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
			m_numberBGGames = 7;
		}
		else
		{
			CBitmap bmp_brush;
			m_numberBGGames = (int)lParam;
			switch(m_numberBGGames)
			{
			case 1:
				bmp_brush.LoadBitmap(IDB_BITMAP_BG1);
				Util_DeleteGdiObject(&m_BrushBG);
				m_BrushBG.CreatePatternBrush(&bmp_brush);
				break;
			case 2:
				bmp_brush.LoadBitmap(IDB_BITMAP_BG2);
				Util_DeleteGdiObject(&m_BrushBG);
				m_BrushBG.CreatePatternBrush(&bmp_brush);
				break;
			case 3:
				bmp_brush.LoadBitmap(IDB_BITMAP_BG3);
				Util_DeleteGdiObject(&m_BrushBG);
				m_BrushBG.CreatePatternBrush(&bmp_brush);
				break;
			case 4:
				bmp_brush.LoadBitmap(IDB_BITMAP_BG4);
				Util_DeleteGdiObject(&m_BrushBG);
				m_BrushBG.CreatePatternBrush(&bmp_brush);
				break;
			case 5:
				bmp_brush.LoadBitmap(IDB_BITMAP_BG5);
				Util_DeleteGdiObject(&m_BrushBG);
				m_BrushBG.CreatePatternBrush(&bmp_brush);
				break;
			case 6:
				bmp_brush.LoadBitmap(IDB_BITMAP_BG6);
				Util_DeleteGdiObject(&m_BrushBG);
				m_BrushBG.CreatePatternBrush(&bmp_brush);
				break;
			case 7:
				Util_DeleteGdiObject(&m_BrushBG);
				m_BrushBG.m_hObject = 
				::CreatePatternBrush((HBITMAP)LoadImage(NULL, m_pAdjustment->m_PageView.m_strBrushBG, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
				break;
			}
		}
		m_pParent->Invalidate();
		break;

	case IDC_LIST_SHIRTS:
		if((int)lParam == 1000)
		{
			m_ShirtImage.LoadFileImage(m_pAdjustment->m_PageView.m_strShirtImage);
			for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)
			{
				m_Pack.GetCard(i)->m_pPicture = m_ShirtImage.m_pPicture;
				m_Pack.GetCard(i)->Invalidate();
			}
			m_numberShirt = 7;
		}
		else
		{
			m_numberShirt = (int)lParam;
			if(m_numberShirt == 7)
			{	
				m_ShirtImage.LoadFileImage(m_pAdjustment->m_PageView.m_strShirtImage);
				for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)
				{
					m_Pack.GetCard(i)->m_pPicture = m_ShirtImage.m_pPicture;
					m_Pack.GetCard(i)->Invalidate();
				}
			}
			else
			{
				for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)
				{
					m_Pack.GetCard(i)->m_pPicture = NULL;
				}
				m_Pack.SetShirt(m_numberShirt-1);
			}
		}
		
		break;
	}

	return LRESULT();
}

//      ,
//        ,
//           .
int CDecoration::MessageWnd(CString str, int flag)
{
	m_pMessageBox->m_strText = str;
	m_pMessageBox->m_Flags = 0;
	m_pMessageBox->m_Flags |= flag;

	if(m_pMessageBox->m_hWnd != 0)
	{
		EndMessageWnd();
		
		return m_pMessageBox->DoModal();
	}
	else
		return m_pMessageBox->DoModal();
}


//    ,
//   .
void CDecoration::EndMessageWnd(void)
{
	if(m_pMessageBox->m_hWnd != 0)
	{
		m_pMessageBox->EndDialog(0);
		m_pMessageBox->DestroyWindow();
		m_pMessageBox->m_nFlags &= ~(WF_MODALLOOP|WF_CONTINUEMODAL);
	}
}

//              
void CDecoration::ReadSettingFromReg(HKEY hkey)
{
	//    
	DWORD defPage = 0;
	Util_ReadIntRegKey( hkey, TEXT("ActiveProperty"), (DWORD*)&m_pAdjustment->m_IndexActivePage,  defPage);
	m_pAdjustment->SetActivePage(m_pAdjustment->m_IndexActivePage);

	//   
	Util_ReadIntRegKey( hkey, TEXT("AmountMoney"), (DWORD*)&m_maxMoney,  100);
	//    
	if(m_maxMoney != 100 && m_maxMoney != 200 && m_maxMoney != 300) 
		m_maxMoney = 100;
	m_pAdjustment->m_PagePublicSetting.SetCheckRadioMoney(m_maxMoney);

	//     
	BOOL is_anim;
	Util_ReadBoolRegKey(hkey, TEXT("AnimationCards"), &is_anim, TRUE);
	m_Pack.ShowAinmationCards(BOOLTobool(is_anim));
	if(is_anim == TRUE)
		m_pAdjustment->m_PagePublicSetting.SetCheckButtons(CPagePublicSetting::chbAnim);

	//      
	BOOL is_requestname;
	Util_ReadBoolRegKey(hkey, TEXT("RequestName"), &is_requestname, TRUE);
	m_RequestName = BOOLTobool(is_requestname);
	if(is_requestname == TRUE)
		m_pAdjustment->m_PagePublicSetting.SetCheckButtons(CPagePublicSetting::chbRequestname);

	//   
	BOOL is_sound;
	Util_ReadBoolRegKey(hkey, TEXT("Sound"), &is_sound, TRUE);
	m_Sound = BOOLTobool(is_sound);
	SetSound(m_Sound);
	if(is_sound == TRUE)
		m_pAdjustment->m_PagePublicSetting.SetCheckButtons(CPagePublicSetting::chbSound);

	//    .
	BOOL chatvisible;
	Util_ReadBoolRegKey(hkey, TEXT("ChatVisible"), &chatvisible, TRUE);
	m_ChatVisible = BOOLTobool(chatvisible);
	if(chatvisible == TRUE)
		m_pAdjustment->m_PagePublicSetting.SetCheckButtons(CPagePublicSetting::chbChat);

	
	//   
	TCHAR name[MAXBUFFERNAMEPLAYER];
	Util_ReadStringRegKeyCch( hkey, TEXT("UserName"),  name, MAXBUFFERNAMEPLAYER/*   */, "");
	m_Player[0].SetName(name);

	CString reg_name;
	int count = 1;
	HRESULT hr = S_OK;
	while(hr == S_OK)
	{
		reg_name.Format("%d", count);
		reg_name.Insert(0, "player");
		TCHAR name[MAXBUFFERNAMEPLAYER] = {NULL};
		hr = Util_ReadStringRegKeyCch(hkey, reg_name.GetBuffer(), name, MAXBUFFERNAMEPLAYER*sizeof(TCHAR), "");
		m_dlgUserName.m_UserNames[count] = name;
		count++;
	}
	

	//     
	DWORD defTable = 2;
	Util_ReadIntRegKey( hkey, TEXT("NumberTable"), (DWORD*)&m_numberTableGames,  defTable);
	m_pAdjustment->m_PageView.SetTable(m_numberTableGames-1);

	TCHAR table_image[512] = {0};
	Util_ReadStringRegKeyCch(hkey, TEXT("TableImage"), table_image, 512, "1.jpg");
	m_pAdjustment->m_PageView.m_strTableImage = table_image;
	m_TableImage.LoadFileImage(m_pAdjustment->m_PageView.m_strTableImage);

	


	//      
	DWORD defBG = 1;
	Util_ReadIntRegKey( hkey, TEXT("NumberBG"), (DWORD*)&m_numberBGGames,  defBG);
	m_pAdjustment->m_PageView.SetBG(m_numberBGGames-1);

	TCHAR brush_bg[512] = {0};
	Util_ReadStringRegKeyCch(hkey, TEXT("BrushBG"), brush_bg, 512, "");
	m_pAdjustment->m_PageView.m_strBrushBG = brush_bg;
	if(m_numberBGGames == 7)
	{
		Util_DeleteGdiObject(&m_BrushBG);
		m_BrushBG.m_hObject = 
				::CreatePatternBrush((HBITMAP)LoadImage(NULL, m_pAdjustment->m_PageView.m_strBrushBG, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
	}


	//     
	DWORD defShirt = 1;
	Util_ReadIntRegKey( hkey, TEXT("NumberShirt"), (DWORD*)&m_numberShirt,  defShirt);
	m_pAdjustment->m_PageView.SetShirt(m_numberShirt-1);
	if(m_numberShirt != 7)
		m_Pack.SetShirt(m_numberShirt-1);

	TCHAR shirt_image[512] = {0};
	Util_ReadStringRegKeyCch(hkey, TEXT("ShirtImage"), shirt_image, 512, "2.jpg");
	m_pAdjustment->m_PageView.m_strShirtImage = shirt_image;
	if(m_numberShirt == 7)
	{
		m_ShirtImage.LoadFileImage(m_pAdjustment->m_PageView.m_strShirtImage);
		for(int i = 0; i < m_Pack.GetNumberCardsInPack(); i++)
		{
			m_Pack.GetCard(i)->m_pPicture = m_ShirtImage.m_pPicture;
		}
	}
}

void CDecoration::WriteSettingToReg(HKEY hkey)
{
	//      
	Util_WriteIntRegKey( hkey, TEXT("ActiveProperty"), m_pAdjustment->m_IndexActivePage);
	//      
    Util_WriteIntRegKey( hkey, TEXT("AmountMoney"), m_maxMoney);

	//    
	if(m_Pack.GetCard(0) != NULL)
		Util_WriteBoolRegKey(hkey, TEXT("AnimationCards"), boolToBOOL(m_Pack.GetCard(0)->m_bAnimCards));

	//        
	Util_WriteBoolRegKey(hkey, TEXT("RequestName"), boolToBOOL(m_RequestName));

	//     
	Util_WriteBoolRegKey(hkey, TEXT("Sound"), boolToBOOL(m_Sound));

	//     .
	Util_WriteBoolRegKey(hkey, TEXT("ChatVisible"), boolToBOOL(m_ChatVisible));

	//   
	Util_WriteStringRegKey( hkey, TEXT("UserName"),  m_Player[0].GetName().GetBuffer());
							

	CString reg_name;
	int count = 0;
	//     
	for(int i = 0; i < MAXNAMEPLAYERS; i++)
	{
		reg_name.Format("%d", count);
		reg_name.Insert(0, "player");
		RegDeleteValue(hkey, reg_name.GetBuffer());
		count++;
	}

	//     
	count = 0;
	while(m_dlgUserName.m_UserNames[count].IsEmpty() == false)
	{
		reg_name.Format("%d", count);
		reg_name.Insert(0, "player");
		Util_WriteStringRegKey(hkey, reg_name.GetBuffer(), m_dlgUserName.m_UserNames[count].GetBuffer());
		count++;
	}


	//     
	Util_WriteIntRegKey( hkey, TEXT("NumberTable"), m_numberTableGames);
	Util_WriteStringRegKey(hkey, TEXT("TableImage"), m_pAdjustment->m_PageView.m_strTableImage.GetBuffer());

	//      
	Util_WriteIntRegKey( hkey, TEXT("NumberBG"), m_numberBGGames);
	Util_WriteStringRegKey(hkey, TEXT("BrushBG"), m_pAdjustment->m_PageView.m_strBrushBG.GetBuffer());
	//     
	Util_WriteIntRegKey( hkey, TEXT("NumberShirt"), m_numberShirt);
	Util_WriteStringRegKey(hkey, TEXT("ShirtImage"), m_pAdjustment->m_PageView.m_strShirtImage.GetBuffer());

	
}

//     
void CDecoration::HelpApp(void)
{
	int i = (int)ShellExecute(m_pParent->m_hWnd, "open", "NineK2.chm", NULL, NULL, SW_SHOWNORMAL);
	if(i == 2)
		MessageWnd("   !", CMessageBox::MMB_OK);
}
