// NameDlg.cpp : implementation file
//

#include "stdafx.h"
//#include "NineK2.h"
#include "NameDlg.h"
#include ".\namedlg.h"


// CNameDlg dialog

IMPLEMENT_DYNAMIC(CNameDlg, CDialog)
CNameDlg::CNameDlg(CWnd* pParent /*=NULL*/)
	: CDialog(IDD_DIALOG_NAME, pParent)
	//, m_strNameUser(_T(""))
	, m_strNameLeft(_T(""))
	, m_strNameTop(_T(""))
	, m_strNameRight(_T(""))
	, m_NumberName(0)
	, m_NetDlg(false)
{
}

CNameDlg::~CNameDlg()
{
}

void CNameDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//DDX_Text(pDX, IDC_COMBO_NAME,      m_strNameUser);
	DDX_CBString(pDX, IDC_COMBO_NAME, m_UserNames[0]);
	DDX_Text(pDX, IDC_EDIT_PLAYERLEFT, m_strNameLeft);
	DDX_Text(pDX, IDC_EDIT_PLAYERTOP,  m_strNameTop);
	DDX_Text(pDX, IDC_EDIT_PLAYERRIGHT,      m_strNameRight);
}


BEGIN_MESSAGE_MAP(CNameDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_COMBO_NAME, OnCbnSelchangeComboName)
END_MESSAGE_MAP()


// CNameDlg message handlers

BOOL CNameDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT(m_NumberName != 0);

	


	if(m_NetDlg == true)
	{
		GetDlgItem(IDC_EDIT_PLAYERLEFT)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_PLAYERTOP)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_PLAYERRIGHT)->EnableWindow(FALSE);
	}

	((CComboBox*)GetDlgItem(IDC_COMBO_NAME))->LimitText(10);
	((CEdit*)GetDlgItem(IDC_EDIT_PLAYERLEFT))->SetLimitText(10);
	((CEdit*)GetDlgItem(IDC_EDIT_PLAYERTOP))->SetLimitText(10);
	((CEdit*)GetDlgItem(IDC_EDIT_PLAYERRIGHT))->SetLimitText(10);
	

	CRect rc;
	if(m_NumberName == 1)
	{
		GetDlgItem(IDC_STATIC_LEFTNAME)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC_TOPNAME)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC_RIGTHNAME)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_EDIT_PLAYERLEFT)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_EDIT_PLAYERTOP)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_EDIT_PLAYERRIGHT)->ShowWindow(SW_HIDE);

		
		GetWindowRect(&rc);
		SetWindowPos(NULL, 0,0,rc.Width(), (int)(rc.Height()/1.5), SWP_NOMOVE);
	}

	if(m_NumberName == 2)
	{
		GetDlgItem(IDC_STATIC_LEFTNAME)->SetWindowText(" ");

		GetDlgItem(IDC_STATIC_TOPNAME)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC_RIGTHNAME)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_EDIT_PLAYERTOP)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_EDIT_PLAYERRIGHT)->ShowWindow(SW_HIDE);
		
		GetWindowRect(&rc);
		SetWindowPos(NULL, 0,0,rc.Width(), (int)(rc.Height()/1.3), SWP_NOMOVE);
	}

	if(m_NumberName == 3)
	{
		GetDlgItem(IDC_STATIC_TOPNAME)->SetWindowText(" ");

		GetDlgItem(IDC_STATIC_RIGTHNAME)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_EDIT_PLAYERRIGHT)->ShowWindow(SW_HIDE);
		
		GetWindowRect(&rc);
		SetWindowPos(NULL, 0,0,rc.Width(), (int)(rc.Height()/1.2), SWP_NOMOVE);
	}

	int distance = 20;
	GetWindowRect(&rc);
	ScreenToClient(&rc);
	CRect button_rect;

	GetDlgItem(IDCANCEL)->GetWindowRect(&button_rect);
	button_rect.top  = (long)(rc.bottom - button_rect.Height()*1.4f);
	button_rect.left = rc.Width()/2 + distance;
	GetDlgItem(IDCANCEL)->SetWindowPos(NULL, button_rect.left, button_rect.top,0,0, SWP_NOSIZE);

	GetDlgItem(IDOK)->GetWindowRect(&button_rect);
	button_rect.top  = (long)(rc.bottom - button_rect.Height()*1.4f);
	button_rect.left = rc.Width()/2 - button_rect.Width() - distance;
	GetDlgItem(IDOK)->SetWindowPos(NULL, button_rect.left, button_rect.top,0,0, SWP_NOSIZE);


	CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_COMBO_NAME);
	pCB->LimitText(MAXBUFFERNAMEPLAYER-2);
	pCB->SetWindowText(m_UserNames[0]);
	for(int i = 1; i < MAXNAMEPLAYERS; i++)
	{
		if(m_UserNames[i].IsEmpty() == false)
			pCB->AddString(m_UserNames[i]);
	}


	HICON icon = LoadIcon(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDI_ICON_APP));
	SetIcon(icon, TRUE);


	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

//        
void CNameDlg::SetNumberName(const int& number_name)
{
	m_NumberName = number_name;
}

void CNameDlg::OnOK()
{
	CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_COMBO_NAME);
	pCB->GetWindowText(m_NamePlayer[0]);
	if(m_NamePlayer[0].IsEmpty() == true)
	{
		m_NamePlayer[0] = _T("");
	}

	CDialog::OnOK();
}

void CNameDlg::OnCbnSelchangeComboName()
{
	CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_COMBO_NAME);

	bool add = true;
	for(int i = 0; i < pCB->GetCount(); i++)
	{
		CString s;
		pCB->GetLBText(i, s);
		if(s == m_NamePlayer[0])
		{
			add = false;
			break;
		}
			
	}

	//      
	//         
	//   
	if(add == true)
		pCB->AddString(m_NamePlayer[0]);
}

